=== modified file 'Makefile.am'
--- Makefile.am	2010-02-10 09:07:38 +0000
+++ Makefile.am	2010-02-12 01:44:42 +0000
@@ -42,7 +42,7 @@
 BUILT_SOURCES=		drizzled/configmake.h
 EXTRA_DIST=		config/config.rpath m4/gnulib-cache.m4 \
 			config/autorun.sh Doxyfile \
-			config/bzr_revinfo \
+			config/pandora_vc_revinfo \
 			extra/run_cpplint.sh  \
 			extra/cpplint.py \
 			extra/clean_source.sh \

=== modified file 'config/pandora-plugin'
--- config/pandora-plugin	2010-01-13 08:20:13 +0000
+++ config/pandora-plugin	2010-02-12 02:56:22 +0000
@@ -212,13 +212,13 @@
     plugin_ac.write("""
 AC_ARG_WITH([%(name_with_dashes)s-plugin],[
 dnl indented wierd to make the help output correct
-AS_HELP_STRING([--with-%(name_with_dashes)s-plugin],[Build %(title)s. @<:@default=yes@:>@])
+AS_HELP_STRING([--with-%(name_with_dashes)s-plugin],[Build %(title)s. @<:@default=%(enabled)s@:>@])
 AS_HELP_STRING([--without-%(name_with_dashes)s-plugin],[Disable building %(title)s])
   ],[
     with_%(name)s_plugin="$withval"
     requested_%(name)s_plugin="yes"
   ],[
-    with_%(name)s_plugin="yes"
+    with_%(name)s_plugin="%(enabled)s"
     requested_%(name)s_plugin="no"
   ])
 AC_ARG_ENABLE([%(name_with_dashes)s-plugin],[
@@ -311,6 +311,7 @@
     plugin['name_with_dashes']= plugin['name'].replace('_','-')
     if plugin.has_key('build_conditional'):
       plugin['has_build_conditional']=True
+      plugin['build_conditional']='"x${with_%(name)s_plugin}" = "xyes" -a %(build_conditional)s' % plugin
     else:
       plugin['has_build_conditional']=False
       plugin['build_conditional']='"x${with_%(name)s_plugin}" = "xyes"' %plugin
@@ -338,6 +339,7 @@
                           license="PLUGIN_LICENSE_GPL",
                           name=os.path.basename(plugin_dir),
                           load_by_default="False",
+                          disabled="False",
                           static="False")
     parser=ConfigParser.ConfigParser(defaults= plugin_defaults)
     parser.read(plugin_file)
@@ -355,6 +357,12 @@
    
     if plugin.has_key('load_by_default'):
       plugin['load_by_default']=parser.getboolean('plugin','load_by_default')
+    if plugin.has_key('disabled'):
+      plugin['disabled']=parser.getboolean('plugin','disabled')
+    if plugin['disabled']:
+      plugin['enabled']="no"
+    else:
+      plugin['enabled']="yes"
     if plugin.has_key('static'):
       plugin['static']= parser.getboolean('plugin','static')
     if plugin.has_key('testsuite'):

=== modified file 'configure.ac'
--- configure.ac	2010-02-10 09:07:38 +0000
+++ configure.ac	2010-02-12 01:44:42 +0000
@@ -22,11 +22,9 @@
 dnl So don't update it here
 AC_INIT([drizzle],[7],[http://bugs.launchpad.net/drizzle])
 AC_CONFIG_SRCDIR([drizzled/drizzled.cc])
-AC_CONFIG_AUX_DIR(config)
-AC_CONFIG_HEADERS([config.h])
-AC_CONFIG_MACRO_DIR([m4])
+AC_CONFIG_AUX_DIR([config])
 
-PANDORA_CANONICAL_TARGET(less-warnings, warnings-always-on, use-gnulib, require-cxx, force-gcc42, skip-visibility, version-from-vc)
+PANDORA_CANONICAL_TARGET(less-warnings, warnings-always-on, require-cxx, force-gcc42, skip-visibility, version-from-vc)
 
 dnl Set the default datadir location to /usr/local/var/drizzle. If a
 dnl localstatedir is explicitly given, just use that.
@@ -39,12 +37,11 @@
       AC_MSG_ERROR("Drizzle requires gperf to build."))
 
 AC_CHECK_PROGS(YACC, ['bison -y'])
-AS_IF([test "x$YACC" = "x" -a "$ac_cv_building_from_bzr" = "yes"],[
+AS_IF([test "x$YACC" = "x" -a "$pandora_building_from_bzr" = "yes"],[
   AC_MSG_ERROR(["bison is required for Drizzle to build from a bzr branch"])
 ])
 
 
-PANDORA_WITH_GETTEXT
 PANDORA_RUN_CPPLINT
 
 PANDORA_REQUIRE_LIBPROTOBUF

=== modified file 'drizzled/charset.cc'
--- drizzled/charset.cc	2010-02-04 08:14:46 +0000
+++ drizzled/charset.cc	2010-02-11 01:35:55 +0000
@@ -16,7 +16,7 @@
 #include "config.h"
 
 #include "drizzled/charset.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/charset_info.h"
 #include "drizzled/internal/m_string.h"
 #include <drizzled/configmake.h>

=== modified file 'drizzled/check_stack_overrun.cc'
--- drizzled/check_stack_overrun.cc	2010-02-04 08:14:46 +0000
+++ drizzled/check_stack_overrun.cc	2010-02-12 01:44:42 +0000
@@ -30,7 +30,7 @@
 /****************************************************************************
 	Check stack size; Send error if there isn't enough stack to continue
 ****************************************************************************/
-#if STACK_DIRECTION < 0
+#if defined(STACK_DIRECTION) && (STACK_DIRECTION < 0)
 #define used_stack(A,B) (long) (A - B)
 #else
 #define used_stack(A,B) (long) (B - A)

=== modified file 'drizzled/db.cc'
--- drizzled/db.cc	2010-02-11 20:01:37 +0000
+++ drizzled/db.cc	2010-02-13 01:41:44 +0000
@@ -26,8 +26,7 @@
 #include <fstream>
 
 #include <drizzled/message/schema.pb.h>
-#include "drizzled/my_error.h"
-#include <drizzled/error.h>
+#include "drizzled/error.h"
 #include <drizzled/gettext.h>
 #include <drizzled/my_hash.h>
 #include "drizzled/internal/m_string.h"

=== modified file 'drizzled/definitions.h'
--- drizzled/definitions.h	2010-02-04 08:14:46 +0000
+++ drizzled/definitions.h	2010-02-12 01:44:42 +0000
@@ -548,10 +548,6 @@
 #endif
 #define ulong_to_double(X) ((double) (ulong) (X))
 
-#ifndef STACK_DIRECTION
-#error "please add -DSTACK_DIRECTION=1 or -1 to your CPPFLAGS"
-#endif
-
 /* From limits.h instead */
 #ifndef DBL_MIN
 #define DBL_MIN    4.94065645841246544e-324

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-02-11 03:49:10 +0000
+++ drizzled/drizzled.cc	2010-02-13 01:41:44 +0000
@@ -32,7 +32,6 @@
 #include "drizzled/internal/my_bit.h"
 #include <drizzled/my_hash.h>
 #include <drizzled/stacktrace.h>
-#include "drizzled/my_error.h"
 #include <drizzled/error.h>
 #include <drizzled/errmsg_print.h>
 #include <drizzled/tztime.h>
@@ -2047,7 +2046,7 @@
 
 /**
   @todo
-  - FIXME add EXIT_TOO_MANY_ARGUMENTS to "drizzled/my_error.h" and return that code?
+  - FIXME add EXIT_TOO_MANY_ARGUMENTS to "drizzled/error.h" and return that code?
 */
 static void get_options(int *argc,char **argv)
 {

=== modified file 'drizzled/error.cc'
--- drizzled/error.cc	2010-02-05 05:07:14 +0000
+++ drizzled/error.cc	2010-02-11 01:35:55 +0000
@@ -1,6 +1,7 @@
 /* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
+ *  Copyright (C) 2000 MySQL AB
  *  Copyright (C) 2008 Sun Microsystems
  *
  *  This program is free software; you can redistribute it and/or modify
@@ -23,10 +24,9 @@
 
 #include "config.h"
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
-#include <drizzled/definitions.h>
-#include <drizzled/error.h>
-#include <drizzled/gettext.h>
+#include "drizzled/definitions.h"
+#include "drizzled/error.h"
+#include "drizzled/gettext.h"
 
 namespace drizzled
 {
@@ -1491,4 +1491,280 @@
   return(false);
 }
 
+// -- From here has just been moved from my_error.cc
+
+/* Error message numbers in global map */
+const char * globerrs[GLOBERRS];
+
+error_handler_func error_handler_hook= NULL;
+
+
+void init_glob_errs()
+{
+  EE(EE_CANTCREATEFILE) = N_("Can't create/write to file '%s' (Errcode: %d)");
+  EE(EE_READ)		= N_("Error reading file '%s' (Errcode: %d)");
+  EE(EE_WRITE)		= N_("Error writing file '%s' (Errcode: %d)");
+  EE(EE_BADCLOSE)	= N_("Error on close of '%s' (Errcode: %d)");
+  EE(EE_OUTOFMEMORY)	= N_("Out of memory (Needed %u bytes)");
+  EE(EE_DELETE)		= N_("Error on delete of '%s' (Errcode: %d)");
+  EE(EE_LINK)		= N_("Error on rename of '%s' to '%s' (Errcode: %d)");
+  EE(EE_EOFERR)		= N_("Unexpected eof found when reading file '%s' (Errcode: %d)");
+  EE(EE_CANTLOCK)	= N_("Can't lock file (Errcode: %d)");
+  EE(EE_CANTUNLOCK)	= N_("Can't unlock file (Errcode: %d)");
+  EE(EE_DIR)		= N_("Can't read dir of '%s' (Errcode: %d)");
+  EE(EE_STAT)		= N_("Can't get stat of '%s' (Errcode: %d)");
+  EE(EE_CANT_CHSIZE)	= N_("Can't change size of file (Errcode: %d)");
+  EE(EE_CANT_OPEN_STREAM)= N_("Can't open stream from handle (Errcode: %d)");
+  EE(EE_GETWD)		= N_("Can't get working dirctory (Errcode: %d)");
+  EE(EE_SETWD)		= N_("Can't change dir to '%s' (Errcode: %d)");
+  EE(EE_LINK_WARNING)	= N_("Warning: '%s' had %d links");
+  EE(EE_OPEN_WARNING)	= N_("Warning: %d files and %d streams is left open\n");
+  EE(EE_DISK_FULL)	= N_("Disk is full writing '%s'. Waiting for someone to free space...");
+  EE(EE_CANT_MKDIR)	= N_("Can't create directory '%s' (Errcode: %d)");
+  EE(EE_UNKNOWN_CHARSET)= N_("Character set '%s' is not a compiled character set and is not specified in the %s file");
+  EE(EE_OUT_OF_FILERESOURCES)= N_("Out of resources when opening file '%s' (Errcode: %d)");
+  EE(EE_CANT_READLINK)= N_("Can't read value for symlink '%s' (Error %d)");
+  EE(EE_CANT_SYMLINK)= N_("Can't create symlink '%s' pointing at '%s' (Error %d)");
+  EE(EE_REALPATH)= N_("Error on realpath() on '%s' (Error %d)");
+  EE(EE_SYNC)=	 N_("Can't sync file '%s' to disk (Errcode: %d)");
+  EE(EE_UNKNOWN_COLLATION)= N_("Collation '%s' is not a compiled collation and is not specified in the %s file");
+  EE(EE_FILENOTFOUND)	= N_("File '%s' not found (Errcode: %d)");
+  EE(EE_FILE_NOT_CLOSED) = N_("File '%s' (fileno: %d) was not closed");
+}
+
+/*
+  WARNING!
+  my_error family functions have to be used according following rules:
+  - if message have not parameters use my_message(ER_CODE, ER(ER_CODE), MYF(N))
+  - if message registered use my_error(ER_CODE, MYF(N), ...).
+  - With some special text of errror message use:
+  my_printf_error(ER_CODE, format, MYF(N), ...)
+*/
+
+/*
+  Message texts are registered into a linked list of 'my_err_head' structs.
+  Each struct contains (1.) an array of pointers to C character strings with
+  '\0' termination, (2.) the error number for the first message in the array
+  (array index 0) and (3.) the error number for the last message in the array
+  (array index (last - first)).
+  The array may contain gaps with NULL pointers and pointers to empty strings.
+  Both kinds of gaps will be translated to "Unknown error %d.", if my_error()
+  is called with a respective error number.
+  The list of header structs is sorted in increasing order of error numbers.
+  Negative error numbers are allowed. Overlap of error numbers is not allowed.
+  Not registered error numbers will be translated to "Unknown error %d.".
+*/
+static struct my_err_head
+{
+  struct my_err_head    *meh_next;      /* chain link */
+  const char            **meh_errmsgs;  /* error messages array */
+  int                   meh_first;      /* error number matching array slot 0 */
+  int                   meh_last;       /* error number matching last slot */
+  bool			is_globerrs;
+} my_errmsgs_globerrs = {NULL, globerrs, EE_ERROR_FIRST, EE_ERROR_LAST, true};
+
+static struct my_err_head *my_errmsgs_list= &my_errmsgs_globerrs;
+
+
+/*
+   Error message to user
+
+   SYNOPSIS
+     my_error()
+       nr	Errno
+       MyFlags	Flags
+       ...	variable list
+*/
+
+void my_error(int nr, myf MyFlags, ...)
+{
+  const char *format;
+  struct my_err_head *meh_p;
+  va_list args;
+  char ebuff[ERRMSGSIZE + 20];
+
+  /* Search for the error messages array, which could contain the message. */
+  for (meh_p= my_errmsgs_list; meh_p; meh_p= meh_p->meh_next)
+    if (nr <= meh_p->meh_last)
+      break;
+
+  /* get the error message string. Default, if NULL or empty string (""). */
+  if (! (format= (meh_p && (nr >= meh_p->meh_first)) ?
+         _(meh_p->meh_errmsgs[nr - meh_p->meh_first]) : NULL) || ! *format)
+    (void) snprintf (ebuff, sizeof(ebuff), _("Unknown error %d"), nr);
+  else
+  {
+    va_start(args,MyFlags);
+    (void) vsnprintf (ebuff, sizeof(ebuff), format, args);
+    va_end(args);
+  }
+  (*error_handler_hook)(nr, ebuff, MyFlags);
+  return;
+}
+
+
+/*
+  Error as printf
+
+         SYNOPSIS
+    my_printf_error()
+      error	Errno
+      format	Format string
+      MyFlags	Flags
+      ...	variable list
+*/
+
+void my_printf_error(uint32_t error, const char *format, myf MyFlags, ...)
+{
+  va_list args;
+  char ebuff[ERRMSGSIZE+20];
+
+  va_start(args,MyFlags);
+  (void) vsnprintf (ebuff, sizeof(ebuff), format, args);
+  va_end(args);
+  (*error_handler_hook)(error, ebuff, MyFlags);
+  return;
+}
+
+/*
+  Give message using error_handler_hook
+
+  SYNOPSIS
+    my_message()
+      error	Errno
+      str	Error message
+      MyFlags	Flags
+*/
+
+void my_message(uint32_t error, const char *str, register myf MyFlags)
+{
+  (*error_handler_hook)(error, str, MyFlags);
+}
+
+
+/*
+  Register error messages for use with my_error().
+
+  SYNOPSIS
+    my_error_register()
+    errmsgs                     array of pointers to error messages
+    first                       error number of first message in the array
+    last                        error number of last message in the array
+
+  DESCRIPTION
+    The pointer array is expected to contain addresses to NUL-terminated
+    C character strings. The array contains (last - first + 1) pointers.
+    NULL pointers and empty strings ("") are allowed. These will be mapped to
+    "Unknown error" when my_error() is called with a matching error number.
+    This function registers the error numbers 'first' to 'last'.
+    No overlapping with previously registered error numbers is allowed.
+
+  RETURN
+    0           OK
+    != 0        Error
+*/
+
+int my_error_register(const char **errmsgs, int first, int last)
+{
+  struct my_err_head *meh_p;
+  struct my_err_head **search_meh_pp;
+
+  /* Allocate a new header structure. */
+  if (! (meh_p= (struct my_err_head*) malloc(sizeof(struct my_err_head))))
+    return 1;
+  meh_p->meh_errmsgs= errmsgs;
+  meh_p->meh_first= first;
+  meh_p->meh_last= last;
+  meh_p->is_globerrs= false;
+
+  /* Search for the right position in the list. */
+  for (search_meh_pp= &my_errmsgs_list;
+       *search_meh_pp;
+       search_meh_pp= &(*search_meh_pp)->meh_next)
+  {
+    if ((*search_meh_pp)->meh_last > first)
+      break;
+  }
+
+  /* Error numbers must be unique. No overlapping is allowed. */
+  if (*search_meh_pp && ((*search_meh_pp)->meh_first <= last))
+  {
+    free((unsigned char*)meh_p);
+    return 1;
+  }
+
+  /* Insert header into the chain. */
+  meh_p->meh_next= *search_meh_pp;
+  *search_meh_pp= meh_p;
+  return 0;
+}
+
+
+/*
+  Unregister formerly registered error messages.
+
+  SYNOPSIS
+    my_error_unregister()
+    first                       error number of first message
+    last                        error number of last message
+
+  DESCRIPTION
+    This function unregisters the error numbers 'first' to 'last'.
+    These must have been previously registered by my_error_register().
+    'first' and 'last' must exactly match the registration.
+    If a matching registration is present, the header is removed from the
+    list and the pointer to the error messages pointers array is returned.
+    Otherwise, NULL is returned.
+
+  RETURN
+    non-NULL    OK, returns address of error messages pointers array.
+    NULL        Error, no such number range registered.
+*/
+
+const char **my_error_unregister(int first, int last)
+{
+  struct my_err_head    *meh_p;
+  struct my_err_head    **search_meh_pp;
+  const char            **errmsgs;
+
+  /* Search for the registration in the list. */
+  for (search_meh_pp= &my_errmsgs_list;
+       *search_meh_pp;
+       search_meh_pp= &(*search_meh_pp)->meh_next)
+  {
+    if (((*search_meh_pp)->meh_first == first) &&
+        ((*search_meh_pp)->meh_last == last))
+      break;
+  }
+  if (! *search_meh_pp)
+    return NULL;
+
+  /* Remove header from the chain. */
+  meh_p= *search_meh_pp;
+  *search_meh_pp= meh_p->meh_next;
+
+  /* Save the return value and free the header. */
+  errmsgs= meh_p->meh_errmsgs;
+  bool is_globerrs= meh_p->is_globerrs;
+
+  free((unsigned char*) meh_p);
+
+  if (is_globerrs)
+    return NULL;
+
+  return errmsgs;
+}
+
+
+void my_error_unregister_all(void)
+{
+  struct my_err_head    *list, *next;
+  for (list= my_errmsgs_globerrs.meh_next; list; list= next)
+  {
+    next= list->meh_next;
+    free((unsigned char*) list);
+  }
+  my_errmsgs_list= &my_errmsgs_globerrs;
+}
+
 } /* namespace drizzled */

=== modified file 'drizzled/error.h'
--- drizzled/error.h	2010-02-05 05:07:14 +0000
+++ drizzled/error.h	2010-02-11 01:35:55 +0000
@@ -20,15 +20,60 @@
 #ifndef DRIZZLED_ERROR_H
 #define DRIZZLED_ERROR_H
 
-#include "drizzled/my_error.h"
+#include "drizzled/definitions.h"
+
+/* Max width of screen (for error messages) */
+#define SC_MAXWIDTH 256
+#define ERRMSGSIZE	(SC_MAXWIDTH)	/* Max length of a error message */
+#define NRERRBUFFS	(2)	/* Buffers for parameters */
+#define MY_FILE_ERROR	((size_t) -1)
+#define ME_FATALERROR   1024    /* Fatal statement error */
 
 namespace drizzled
 {
 
+typedef void (*error_handler_func)(uint32_t my_err,
+                                   const char *str,
+                                   myf MyFlags);
+extern error_handler_func error_handler_hook;
+
 bool init_errmessage(void);
 const char * error_message(unsigned int err_index);
 
 enum drizzled_error_code {
+
+  EE_ERROR_FIRST=1,
+  EE_CANTCREATEFILE,
+  EE_READ,
+  EE_WRITE,
+  EE_BADCLOSE,
+  EE_OUTOFMEMORY,
+  EE_DELETE,
+  EE_LINK,
+  EE_EOFERR,
+  EE_CANTLOCK,
+  EE_CANTUNLOCK,
+  EE_DIR,
+  EE_STAT,
+  EE_CANT_CHSIZE,
+  EE_CANT_OPEN_STREAM,
+  EE_GETWD,
+  EE_SETWD,
+  EE_LINK_WARNING,
+  EE_OPEN_WARNING,
+  EE_DISK_FULL,
+  EE_CANT_MKDIR,
+  EE_UNKNOWN_CHARSET,
+  EE_OUT_OF_FILERESOURCES,
+  EE_CANT_READLINK,
+  EE_CANT_SYMLINK,
+  EE_REALPATH,
+  EE_SYNC,
+  EE_UNKNOWN_COLLATION,
+  EE_FILENOTFOUND,
+  EE_FILE_NOT_CLOSED,
+  EE_ERROR_LAST= EE_FILE_NOT_CLOSED,
+
   ER_ERROR_FIRST= 1000,
   ER_UNUSED1000= ER_ERROR_FIRST,
   ER_UNUSED1001,
@@ -727,6 +772,40 @@
   ER_ERROR_LAST= ER_CORRUPT_TABLE_DEFINITION
 };
 
+enum drizzle_exit_codes {
+  EXIT_UNSPECIFIED_ERROR = 1,
+  EXIT_UNKNOWN_OPTION,
+  EXIT_AMBIGUOUS_OPTION,
+  EXIT_NO_ARGUMENT_ALLOWED,
+  EXIT_ARGUMENT_REQUIRED,
+  EXIT_VAR_PREFIX_NOT_UNIQUE,
+  EXIT_UNKNOWN_VARIABLE,
+  EXIT_OUT_OF_MEMORY,
+  EXIT_UNKNOWN_SUFFIX,
+  EXIT_NO_PTR_TO_VARIABLE,
+  EXIT_CANNOT_CONNECT_TO_SERVICE,
+  EXIT_OPTION_DISABLED,
+  EXIT_ARGUMENT_INVALID
+};
+
+
+#define GLOBERRS (EE_ERROR_LAST - EE_ERROR_FIRST + 1) /* Nr of global errors */
+#define EE(X)    (globerrs[(X) - EE_ERROR_FIRST])
+
+/* Error message numbers in global map */
+extern const char * globerrs[GLOBERRS];
+
+void init_glob_errs(void);
+void my_error(int nr,myf MyFlags, ...);
+void my_printf_error(uint32_t my_err, const char *format,
+                     myf MyFlags, ...)
+                     __attribute__((format(printf, 2, 4)));
+int my_error_register(const char **errmsgs, int first, int last);
+void my_error_unregister_all(void);
+const char **my_error_unregister(int first, int last);
+void my_message(uint32_t my_err, const char *str,myf MyFlags);
+void my_message_no_curses(uint32_t my_err, const char *str,myf MyFlags);
+
 } /* namespace drizzled */
 
 #endif /* DRIZZLED_ERROR_H */

=== modified file 'drizzled/function/str/user.cc'
--- drizzled/function/str/user.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/user.cc	2010-02-10 23:50:24 +0000
@@ -57,8 +57,8 @@
 bool Item_func_user::fix_fields(Session *session, Item **ref)
 {
   return (Item_str_func::fix_fields(session, ref) ||
-          init(session->security_ctx.user.c_str(),
-               session->security_ctx.ip.c_str()));
+          init(session->getSecurityContext().getUser().c_str(),
+               session->getSecurityContext().getIp().c_str()));
 }
 
 
@@ -67,8 +67,8 @@
   if (Item_str_func::fix_fields(session, ref))
     return true;
 
-  Security_context *ctx= &session->security_ctx;
-  return init(ctx->user.c_str(), ctx->ip.c_str());
+  const SecurityContext *ctx= &session->getSecurityContext();
+  return init(ctx->getUser().c_str(), ctx->getIp().c_str());
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-02-11 03:49:10 +0000
+++ drizzled/include.am	2010-02-13 01:41:44 +0000
@@ -263,7 +263,6 @@
 			      drizzled/memory/multi_malloc.h \
 			      drizzled/memory/root.h \
 			      drizzled/my_decimal.h \
-			      drizzled/my_error.h \
 			      drizzled/my_getopt.h \
 			      drizzled/my_hash.h \
 			      drizzled/my_time.h \
@@ -465,7 +464,6 @@
 			    drizzled/drizzled.cc \
 			    drizzled/dtcollation.cc \
 			    drizzled/errmsg_print.cc \
-			    drizzled/error.cc \
 			    drizzled/field.cc \
 			    drizzled/field/blob.cc \
 			    drizzled/field/date.cc \
@@ -778,7 +776,7 @@
 				drizzled/ctype.cc
 
 drizzled_libdynamic_array_la_SOURCES = drizzled/dynamic_array.cc
-drizzled_liberror_la_SOURCES = drizzled/my_error.cc
+drizzled_liberror_la_SOURCES = drizzled/error.cc
 drizzled_libgetopt_la_SOURCES = drizzled/my_getopt.cc
 drizzled_libtypelib_la_SOURCES = drizzled/typelib.cc
 drizzled_libserialutil_la_SOURCES = drizzled/db.cc drizzled/table_proto_write.cc

=== modified file 'drizzled/internal/mf_cache.cc'
--- drizzled/internal/mf_cache.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/mf_cache.cc	2010-02-11 01:35:55 +0000
@@ -20,8 +20,8 @@
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/m_string.h"
 #include "drizzled/internal/my_static.h"
-#include "drizzled/my_error.h"
 #include "drizzled/internal/iocache.h"
+#include "drizzled/error.h"
 
 namespace drizzled
 {

=== modified file 'drizzled/internal/mf_iocache.cc'
--- drizzled/internal/mf_iocache.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/mf_iocache.cc	2010-02-11 01:35:55 +0000
@@ -52,7 +52,7 @@
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/m_string.h"
 #ifdef HAVE_AIOWAIT
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/internal/aio_result.h"
 static void my_aiowait(my_aio_result *result);
 #endif

=== modified file 'drizzled/internal/mf_tempfile.cc'
--- drizzled/internal/mf_tempfile.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/mf_tempfile.cc	2010-02-11 01:35:55 +0000
@@ -18,7 +18,7 @@
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/m_string.h"
 #include "my_static.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include <stdio.h>
 #include <errno.h>
 #include <string>

=== modified file 'drizzled/internal/my_create.cc'
--- drizzled/internal/my_create.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_create.cc	2010-02-11 01:35:55 +0000
@@ -20,7 +20,7 @@
 #include <fcntl.h>
 #include <errno.h>
 
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 	/*
 	** Create a new file

=== modified file 'drizzled/internal/my_delete.cc'
--- drizzled/internal/my_delete.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_delete.cc	2010-02-11 01:35:55 +0000
@@ -16,7 +16,7 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 namespace drizzled
 {

=== modified file 'drizzled/internal/my_init.cc'
--- drizzled/internal/my_init.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_init.cc	2010-02-11 01:35:55 +0000
@@ -17,7 +17,7 @@
 
 #include "drizzled/internal/my_sys.h"
 #include "my_static.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/internal/m_string.h"
 #include "drizzled/charset_info.h"
 #include "drizzled/charset.h"

=== modified file 'drizzled/internal/my_open.cc'
--- drizzled/internal/my_open.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_open.cc	2010-02-11 01:35:55 +0000
@@ -16,7 +16,7 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #include <fcntl.h>
 

=== modified file 'drizzled/internal/my_read.cc'
--- drizzled/internal/my_read.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_read.cc	2010-02-11 01:35:55 +0000
@@ -16,7 +16,7 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include <errno.h>
 
 namespace drizzled

=== modified file 'drizzled/internal/my_redel.cc'
--- drizzled/internal/my_redel.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_redel.cc	2010-02-11 01:35:55 +0000
@@ -17,7 +17,7 @@
 
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/m_string.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #if defined(HAVE_UTIME_H)
 #include <utime.h>
 #elif defined(HAVE_SYS_UTIME_H)

=== modified file 'drizzled/internal/my_rename.cc'
--- drizzled/internal/my_rename.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_rename.cc	2010-02-11 01:35:55 +0000
@@ -16,7 +16,7 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/internal/m_string.h"
 
 namespace drizzled

=== modified file 'drizzled/internal/my_static.cc'
--- drizzled/internal/my_static.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_static.cc	2010-02-11 01:35:55 +0000
@@ -21,7 +21,7 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "my_static.h"
 #include <stdlib.h>
 

=== modified file 'drizzled/internal/my_symlink.cc'
--- drizzled/internal/my_symlink.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_symlink.cc	2010-02-11 01:35:55 +0000
@@ -16,7 +16,7 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/internal/m_string.h"
 #include <errno.h>
 

=== modified file 'drizzled/internal/my_symlink2.cc'
--- drizzled/internal/my_symlink2.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_symlink2.cc	2010-02-11 01:35:55 +0000
@@ -23,7 +23,7 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/internal/m_string.h"
 
 namespace drizzled

=== modified file 'drizzled/internal/my_sync.cc'
--- drizzled/internal/my_sync.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_sync.cc	2010-02-11 01:35:55 +0000
@@ -19,7 +19,7 @@
 #include <errno.h>
 #include <fcntl.h>
 
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 namespace drizzled
 {

=== modified file 'drizzled/internal/my_sys.h'
--- drizzled/internal/my_sys.h	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_sys.h	2010-02-11 01:35:55 +0000
@@ -37,7 +37,7 @@
 #include "drizzled/internal/aio_result.h"
 
 #include "drizzled/memory/root.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #ifndef errno				/* did we already get it? */
 #ifdef HAVE_ERRNO_AS_DEFINE

=== modified file 'drizzled/internal/my_write.cc'
--- drizzled/internal/my_write.cc	2010-02-04 08:14:46 +0000
+++ drizzled/internal/my_write.cc	2010-02-11 01:35:55 +0000
@@ -16,8 +16,8 @@
 #include "config.h"
 
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
-#include <errno.h>
+#include "drizzled/error.h"
+#include <cerrno>
 
 namespace drizzled
 {

=== removed file 'drizzled/my_error.cc'
--- drizzled/my_error.cc	2010-02-04 08:14:46 +0000
+++ drizzled/my_error.cc	1970-01-01 00:00:00 +0000
@@ -1,302 +0,0 @@
-/* Copyright (C) 2000 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-#include "config.h"
-
-#include <cstdio>
-#include <stdarg.h>
-
-#include <drizzled/gettext.h>
-#include "drizzled/my_error.h"
-#include "drizzled/definitions.h"
-
-namespace drizzled
-{
-
-/* Error message numbers in global map */
-const char * globerrs[GLOBERRS];
-
-error_handler_func error_handler_hook= NULL;
-
-
-void init_glob_errs()
-{
-  EE(EE_CANTCREATEFILE) = N_("Can't create/write to file '%s' (Errcode: %d)");
-  EE(EE_READ)		= N_("Error reading file '%s' (Errcode: %d)");
-  EE(EE_WRITE)		= N_("Error writing file '%s' (Errcode: %d)");
-  EE(EE_BADCLOSE)	= N_("Error on close of '%s' (Errcode: %d)");
-  EE(EE_OUTOFMEMORY)	= N_("Out of memory (Needed %u bytes)");
-  EE(EE_DELETE)		= N_("Error on delete of '%s' (Errcode: %d)");
-  EE(EE_LINK)		= N_("Error on rename of '%s' to '%s' (Errcode: %d)");
-  EE(EE_EOFERR)		= N_("Unexpected eof found when reading file '%s' (Errcode: %d)");
-  EE(EE_CANTLOCK)	= N_("Can't lock file (Errcode: %d)");
-  EE(EE_CANTUNLOCK)	= N_("Can't unlock file (Errcode: %d)");
-  EE(EE_DIR)		= N_("Can't read dir of '%s' (Errcode: %d)");
-  EE(EE_STAT)		= N_("Can't get stat of '%s' (Errcode: %d)");
-  EE(EE_CANT_CHSIZE)	= N_("Can't change size of file (Errcode: %d)");
-  EE(EE_CANT_OPEN_STREAM)= N_("Can't open stream from handle (Errcode: %d)");
-  EE(EE_GETWD)		= N_("Can't get working dirctory (Errcode: %d)");
-  EE(EE_SETWD)		= N_("Can't change dir to '%s' (Errcode: %d)");
-  EE(EE_LINK_WARNING)	= N_("Warning: '%s' had %d links");
-  EE(EE_OPEN_WARNING)	= N_("Warning: %d files and %d streams is left open\n");
-  EE(EE_DISK_FULL)	= N_("Disk is full writing '%s'. Waiting for someone to free space...");
-  EE(EE_CANT_MKDIR)	= N_("Can't create directory '%s' (Errcode: %d)");
-  EE(EE_UNKNOWN_CHARSET)= N_("Character set '%s' is not a compiled character set and is not specified in the %s file");
-  EE(EE_OUT_OF_FILERESOURCES)= N_("Out of resources when opening file '%s' (Errcode: %d)");
-  EE(EE_CANT_READLINK)= N_("Can't read value for symlink '%s' (Error %d)");
-  EE(EE_CANT_SYMLINK)= N_("Can't create symlink '%s' pointing at '%s' (Error %d)");
-  EE(EE_REALPATH)= N_("Error on realpath() on '%s' (Error %d)");
-  EE(EE_SYNC)=	 N_("Can't sync file '%s' to disk (Errcode: %d)");
-  EE(EE_UNKNOWN_COLLATION)= N_("Collation '%s' is not a compiled collation and is not specified in the %s file");
-  EE(EE_FILENOTFOUND)	= N_("File '%s' not found (Errcode: %d)");
-  EE(EE_FILE_NOT_CLOSED) = N_("File '%s' (fileno: %d) was not closed");
-}
-
-/*
-  WARNING!
-  my_error family functions have to be used according following rules:
-  - if message have not parameters use my_message(ER_CODE, ER(ER_CODE), MYF(N))
-  - if message registered use my_error(ER_CODE, MYF(N), ...).
-  - With some special text of errror message use:
-  my_printf_error(ER_CODE, format, MYF(N), ...)
-*/
-
-/*
-  Message texts are registered into a linked list of 'my_err_head' structs.
-  Each struct contains (1.) an array of pointers to C character strings with
-  '\0' termination, (2.) the error number for the first message in the array
-  (array index 0) and (3.) the error number for the last message in the array
-  (array index (last - first)).
-  The array may contain gaps with NULL pointers and pointers to empty strings.
-  Both kinds of gaps will be translated to "Unknown error %d.", if my_error()
-  is called with a respective error number.
-  The list of header structs is sorted in increasing order of error numbers.
-  Negative error numbers are allowed. Overlap of error numbers is not allowed.
-  Not registered error numbers will be translated to "Unknown error %d.".
-*/
-static struct my_err_head
-{
-  struct my_err_head    *meh_next;      /* chain link */
-  const char            **meh_errmsgs;  /* error messages array */
-  int                   meh_first;      /* error number matching array slot 0 */
-  int                   meh_last;       /* error number matching last slot */
-  bool			is_globerrs;
-} my_errmsgs_globerrs = {NULL, globerrs, EE_ERROR_FIRST, EE_ERROR_LAST, true};
-
-static struct my_err_head *my_errmsgs_list= &my_errmsgs_globerrs;
-
-
-/*
-   Error message to user
-
-   SYNOPSIS
-     my_error()
-       nr	Errno
-       MyFlags	Flags
-       ...	variable list
-*/
-
-void my_error(int nr, myf MyFlags, ...)
-{
-  const char *format;
-  struct my_err_head *meh_p;
-  va_list args;
-  char ebuff[ERRMSGSIZE + 20];
-
-  /* Search for the error messages array, which could contain the message. */
-  for (meh_p= my_errmsgs_list; meh_p; meh_p= meh_p->meh_next)
-    if (nr <= meh_p->meh_last)
-      break;
-
-  /* get the error message string. Default, if NULL or empty string (""). */
-  if (! (format= (meh_p && (nr >= meh_p->meh_first)) ?
-         _(meh_p->meh_errmsgs[nr - meh_p->meh_first]) : NULL) || ! *format)
-    (void) snprintf (ebuff, sizeof(ebuff), _("Unknown error %d"), nr);
-  else
-  {
-    va_start(args,MyFlags);
-    (void) vsnprintf (ebuff, sizeof(ebuff), format, args);
-    va_end(args);
-  }
-  (*error_handler_hook)(nr, ebuff, MyFlags);
-  return;
-}
-
-
-/*
-  Error as printf
-
-  SYNOPSIS
-    my_printf_error()
-      error	Errno
-      format	Format string
-      MyFlags	Flags
-      ...	variable list
-*/
-
-void my_printf_error(uint32_t error, const char *format, myf MyFlags, ...)
-{
-  va_list args;
-  char ebuff[ERRMSGSIZE+20];
-
-  va_start(args,MyFlags);
-  (void) vsnprintf (ebuff, sizeof(ebuff), format, args);
-  va_end(args);
-  (*error_handler_hook)(error, ebuff, MyFlags);
-  return;
-}
-
-/*
-  Give message using error_handler_hook
-
-  SYNOPSIS
-    my_message()
-      error	Errno
-      str	Error message
-      MyFlags	Flags
-*/
-
-void my_message(uint32_t error, const char *str, register myf MyFlags)
-{
-  (*error_handler_hook)(error, str, MyFlags);
-}
-
-
-/*
-  Register error messages for use with my_error().
-
-  SYNOPSIS
-    my_error_register()
-    errmsgs                     array of pointers to error messages
-    first                       error number of first message in the array
-    last                        error number of last message in the array
-
-  DESCRIPTION
-    The pointer array is expected to contain addresses to NUL-terminated
-    C character strings. The array contains (last - first + 1) pointers.
-    NULL pointers and empty strings ("") are allowed. These will be mapped to
-    "Unknown error" when my_error() is called with a matching error number.
-    This function registers the error numbers 'first' to 'last'.
-    No overlapping with previously registered error numbers is allowed.
-
-  RETURN
-    0           OK
-    != 0        Error
-*/
-
-int my_error_register(const char **errmsgs, int first, int last)
-{
-  struct my_err_head *meh_p;
-  struct my_err_head **search_meh_pp;
-
-  /* Allocate a new header structure. */
-  if (! (meh_p= (struct my_err_head*) malloc(sizeof(struct my_err_head))))
-    return 1;
-  meh_p->meh_errmsgs= errmsgs;
-  meh_p->meh_first= first;
-  meh_p->meh_last= last;
-  meh_p->is_globerrs= false;
-
-  /* Search for the right position in the list. */
-  for (search_meh_pp= &my_errmsgs_list;
-       *search_meh_pp;
-       search_meh_pp= &(*search_meh_pp)->meh_next)
-  {
-    if ((*search_meh_pp)->meh_last > first)
-      break;
-  }
-
-  /* Error numbers must be unique. No overlapping is allowed. */
-  if (*search_meh_pp && ((*search_meh_pp)->meh_first <= last))
-  {
-    free((unsigned char*)meh_p);
-    return 1;
-  }
-
-  /* Insert header into the chain. */
-  meh_p->meh_next= *search_meh_pp;
-  *search_meh_pp= meh_p;
-  return 0;
-}
-
-
-/*
-  Unregister formerly registered error messages.
-
-  SYNOPSIS
-    my_error_unregister()
-    first                       error number of first message
-    last                        error number of last message
-
-  DESCRIPTION
-    This function unregisters the error numbers 'first' to 'last'.
-    These must have been previously registered by my_error_register().
-    'first' and 'last' must exactly match the registration.
-    If a matching registration is present, the header is removed from the
-    list and the pointer to the error messages pointers array is returned.
-    Otherwise, NULL is returned.
-
-  RETURN
-    non-NULL    OK, returns address of error messages pointers array.
-    NULL        Error, no such number range registered.
-*/
-
-const char **my_error_unregister(int first, int last)
-{
-  struct my_err_head    *meh_p;
-  struct my_err_head    **search_meh_pp;
-  const char            **errmsgs;
-
-  /* Search for the registration in the list. */
-  for (search_meh_pp= &my_errmsgs_list;
-       *search_meh_pp;
-       search_meh_pp= &(*search_meh_pp)->meh_next)
-  {
-    if (((*search_meh_pp)->meh_first == first) &&
-        ((*search_meh_pp)->meh_last == last))
-      break;
-  }
-  if (! *search_meh_pp)
-    return NULL;
-
-  /* Remove header from the chain. */
-  meh_p= *search_meh_pp;
-  *search_meh_pp= meh_p->meh_next;
-
-  /* Save the return value and free the header. */
-  errmsgs= meh_p->meh_errmsgs;
-  bool is_globerrs= meh_p->is_globerrs;
-
-  free((unsigned char*) meh_p);
-
-  if (is_globerrs)
-    return NULL;
-
-  return errmsgs;
-}
-
-
-void my_error_unregister_all(void)
-{
-  struct my_err_head    *list, *next;
-  for (list= my_errmsgs_globerrs.meh_next; list; list= next)
-  {
-    next= list->meh_next;
-    free((unsigned char*) list);
-  }
-  my_errmsgs_list= &my_errmsgs_globerrs;
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/my_error.h'
--- drizzled/my_error.h	2010-02-04 08:14:46 +0000
+++ drizzled/my_error.h	1970-01-01 00:00:00 +0000
@@ -1,115 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_MY_ERROR_H
-#define DRIZZLED_MY_ERROR_H
-
-#include "drizzled/definitions.h"
-
-namespace drizzled
-{
-
-/* Max width of screen (for error messages) */
-#define SC_MAXWIDTH 256
-#define ERRMSGSIZE	(SC_MAXWIDTH)	/* Max length of a error message */
-#define NRERRBUFFS	(2)	/* Buffers for parameters */
-#define MY_FILE_ERROR	((size_t) -1)
-#define ME_FATALERROR   1024    /* Fatal statement error */
-
-typedef void (*error_handler_func)(uint32_t my_err, const char *str,myf MyFlags);
-extern error_handler_func error_handler_hook;
-
-/*
-  Do not add error numbers before EE_ERROR_FIRST.
-  If necessary to add lower numbers, change EE_ERROR_FIRST accordingly.
-
-  We start with error 1 to not confuse peoples with 'error 0'
-*/
-
-#define EE_ERROR_FIRST          1 /*Copy first error nr.*/
-#define EE_CANTCREATEFILE	1
-#define EE_READ			2
-#define EE_WRITE		3
-#define EE_BADCLOSE		4
-#define EE_OUTOFMEMORY		5
-#define EE_DELETE		6
-#define EE_LINK			7
-#define EE_EOFERR		9
-#define EE_CANTLOCK		10
-#define EE_CANTUNLOCK		11
-#define EE_DIR			12
-#define EE_STAT			13
-#define EE_CANT_CHSIZE		14
-#define EE_CANT_OPEN_STREAM	15
-#define EE_GETWD		16
-#define EE_SETWD		17
-#define EE_LINK_WARNING		18
-#define EE_OPEN_WARNING		19
-#define EE_DISK_FULL		20
-#define EE_CANT_MKDIR		21
-#define EE_UNKNOWN_CHARSET	22
-#define EE_OUT_OF_FILERESOURCES	23
-#define EE_CANT_READLINK	24
-#define EE_CANT_SYMLINK		25
-#define EE_REALPATH		26
-#define EE_SYNC			27
-#define EE_UNKNOWN_COLLATION	28
-#define EE_FILENOTFOUND		29
-#define EE_FILE_NOT_CLOSED	30
-#define EE_ERROR_LAST           30 /* Copy last error nr */
-/* Add error numbers before EE_ERROR_LAST and change it accordingly. */
-
-  /* exit codes for all MySQL programs */
-
-#define EXIT_UNSPECIFIED_ERROR		1
-#define EXIT_UNKNOWN_OPTION		2
-#define EXIT_AMBIGUOUS_OPTION		3
-#define EXIT_NO_ARGUMENT_ALLOWED	4
-#define EXIT_ARGUMENT_REQUIRED		5
-#define EXIT_VAR_PREFIX_NOT_UNIQUE	6
-#define EXIT_UNKNOWN_VARIABLE		7
-#define EXIT_OUT_OF_MEMORY		8
-#define EXIT_UNKNOWN_SUFFIX		9
-#define EXIT_NO_PTR_TO_VARIABLE		10
-#define EXIT_CANNOT_CONNECT_TO_SERVICE	11
-#define EXIT_OPTION_DISABLED            12
-#define EXIT_ARGUMENT_INVALID           13
-
-#define GLOBERRS (EE_ERROR_LAST - EE_ERROR_FIRST + 1) /* Nr of global errors */
-#define EE(X)    (globerrs[(X) - EE_ERROR_FIRST])
-
-/* Error message numbers in global map */
-extern const char * globerrs[GLOBERRS];
-
-void init_glob_errs(void);
-void my_error(int nr,myf MyFlags, ...);
-void my_printf_error(uint32_t my_err, const char *format,
-                     myf MyFlags, ...)
-                     __attribute__((format(printf, 2, 4)));
-int my_error_register(const char **errmsgs, int first, int last);
-void my_error_unregister_all(void);
-const char **my_error_unregister(int first, int last);
-void my_message(uint32_t my_err, const char *str,myf MyFlags);
-void my_message_no_curses(uint32_t my_err, const char *str,myf MyFlags);
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_MY_ERROR_H */
-
-

=== modified file 'drizzled/my_getopt.cc'
--- drizzled/my_getopt.cc	2010-02-04 08:14:46 +0000
+++ drizzled/my_getopt.cc	2010-02-11 01:35:55 +0000
@@ -19,7 +19,7 @@
 
 #include "drizzled/internal/m_string.h"
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/my_getopt.h"
 
 #include <stdio.h>

=== modified file 'drizzled/name_resolution_context.h'
--- drizzled/name_resolution_context.h	2010-02-04 08:14:46 +0000
+++ drizzled/name_resolution_context.h	2010-02-10 23:50:24 +0000
@@ -26,7 +26,7 @@
 {
 
 class TableList;
-class Security_context;
+class SecurityContext;
 class Session;
 class Select_Lex;
 
@@ -105,7 +105,7 @@
    * Security context of this name resolution context. It's used for views
    * and is non-zero only if the view is defined with SQL SECURITY DEFINER.
    */
-  Security_context *security_ctx;
+  SecurityContext *security_ctx;
 
   Name_resolution_context()
     :

=== modified file 'drizzled/optimizer/quick_range_select.cc'
--- drizzled/optimizer/quick_range_select.cc	2010-02-04 08:14:46 +0000
+++ drizzled/optimizer/quick_range_select.cc	2010-02-10 16:26:01 +0000
@@ -39,6 +39,8 @@
                                               memory::Root *parent_alloc,
                                               bool *create_error)
   :
+    mrr_flags(0),
+    alloc(),
     cursor(NULL),
     ranges(),
     in_ror_merged_scan(false),
@@ -52,9 +54,7 @@
     mrr_buf_size(0),
     mrr_buf_desc(NULL),
     key_parts(NULL),
-    dont_free(false),
-    mrr_flags(0),
-    alloc()
+    dont_free(false)
 {
   my_bitmap_map *bitmap= NULL;
 

=== modified file 'drizzled/optimizer/quick_range_select.h'
--- drizzled/optimizer/quick_range_select.h	2010-02-04 08:14:46 +0000
+++ drizzled/optimizer/quick_range_select.h	2010-02-08 20:09:58 +0000
@@ -40,62 +40,6 @@
  */
 class QuickRangeSelect : public QuickSelectInterface
 {
-protected:
-  Cursor *cursor;
-  DYNAMIC_ARRAY ranges; /**< ordered array of range ptrs */
-
-  /** Members to deal with case when this quick select is a ROR-merged scan */
-  bool in_ror_merged_scan;
-  MyBitmap column_bitmap;
-  MyBitmap *save_read_set;
-  MyBitmap *save_write_set;
-  bool free_file; /**< True when this->file is "owned" by this quick select */
-
-  /* Range pointers to be used when not using MRR interface */
-  QuickRange **cur_range; /**< current element in ranges  */
-  QuickRange *last_range;
-
-  /** Members needed to use the MRR interface */
-  QuickRangeSequenceContext qr_traversal_ctx;
-  uint32_t mrr_buf_size; /**< copy from session->variables.read_rnd_buff_size */
-  HANDLER_BUFFER *mrr_buf_desc; /**< the Cursor buffer */
-
-  /** Info about index we're scanning */
-  KEY_PART *key_parts;
-  KEY_PART_INFO *key_part_info;
-
-  bool dont_free; /**< Used by QuickSelectDescending */
-
-  /**
-   * Compare if found key is over max-value
-   * @return 0 if key <= range->max_key
-   * @todo: Figure out why can't this function be as simple as cmp_prev().
-   */
-  int cmp_next(QuickRange *range);
-
-  /**
-   * @return 0 if found key is inside range (found key >= range->min_key).
-   */
-  int cmp_prev(QuickRange *range);
-
-  /**
-   * Check if current row will be retrieved by this QuickRangeSelect
-   *
-   * NOTES
-   * It is assumed that currently a scan is being done on another index
-   * which reads all necessary parts of the index that is scanned by this
-   * quick select.
-   * The implementation does a binary search on sorted array of disjoint
-   * ranges, without taking size of range into account.
-   *
-   * This function is used to filter out clustered PK scan rows in
-   * index_merge quick select.
-   *
-   * RETURN
-   * @retval true  if current row will be retrieved by this quick select
-   * false if not
-   */
-  bool row_in_ranges();
 
 public:
 
@@ -213,6 +157,64 @@
     cursor= NULL;
   }
 
+protected:
+
+  Cursor *cursor;
+  DYNAMIC_ARRAY ranges; /**< ordered array of range ptrs */
+
+  /** Members to deal with case when this quick select is a ROR-merged scan */
+  bool in_ror_merged_scan;
+  MyBitmap column_bitmap;
+  MyBitmap *save_read_set;
+  MyBitmap *save_write_set;
+  bool free_file; /**< True when this->file is "owned" by this quick select */
+
+  /* Range pointers to be used when not using MRR interface */
+  QuickRange **cur_range; /**< current element in ranges  */
+  QuickRange *last_range;
+
+  /** Members needed to use the MRR interface */
+  QuickRangeSequenceContext qr_traversal_ctx;
+  uint32_t mrr_buf_size; /**< copy from session->variables.read_rnd_buff_size */
+  HANDLER_BUFFER *mrr_buf_desc; /**< the Cursor buffer */
+
+  /** Info about index we're scanning */
+  KEY_PART *key_parts;
+  KEY_PART_INFO *key_part_info;
+
+  bool dont_free; /**< Used by QuickSelectDescending */
+
+  /**
+   * Compare if found key is over max-value
+   * @return 0 if key <= range->max_key
+   * @todo: Figure out why can't this function be as simple as cmp_prev().
+   */
+  int cmp_next(QuickRange *range);
+
+  /**
+   * @return 0 if found key is inside range (found key >= range->min_key).
+   */
+  int cmp_prev(QuickRange *range);
+
+  /**
+   * Check if current row will be retrieved by this QuickRangeSelect
+   *
+   * NOTES
+   * It is assumed that currently a scan is being done on another index
+   * which reads all necessary parts of the index that is scanned by this
+   * quick select.
+   * The implementation does a binary search on sorted array of disjoint
+   * ranges, without taking size of range into account.
+   *
+   * This function is used to filter out clustered PK scan rows in
+   * index_merge quick select.
+   *
+   * RETURN
+   * @retval true  if current row will be retrieved by this quick select
+   * false if not
+   */
+  bool row_in_ranges();
+
 private:
 
   /* Used only by QuickSelectDescending */

=== modified file 'drizzled/optimizer/range.cc'
--- drizzled/optimizer/range.cc	2010-02-04 08:14:46 +0000
+++ drizzled/optimizer/range.cc	2010-02-10 20:00:52 +0000
@@ -348,6 +348,9 @@
                                 const char *msg,
                                 struct st_ror_scan_info **start,
                                 struct st_ror_scan_info **end);
+static void print_ror_scans_vector(Table *table,
+                                   const char *msg,
+                                   vector<struct st_ror_scan_info *> &vec);
 
 static SEL_TREE *tree_and(optimizer::RangeParameter *param, SEL_TREE *tree1, SEL_TREE *tree2);
 
@@ -1084,7 +1087,7 @@
               Try constructing covering ROR-intersect only if it looks possible
               and worth doing.
             */
-            if (!rori_trp->is_covering && can_build_covering &&
+            if (rori_trp->isRowRetrievalNecessary() && can_build_covering &&
                 (rori_trp= get_best_covering_ror_intersect(&param, tree,
                                                            best_read_time)))
               best_trp= rori_trp;
@@ -1260,7 +1263,7 @@
     all_scans_ror_able &= ((*ptree)->n_ror_scans > 0);
     all_scans_rors &= (*cur_child)->is_ror;
     if (pk_is_clustered &&
-        param->real_keynr[(*cur_child)->key_idx] ==
+        param->real_keynr[(*cur_child)->getKeyIndex()] ==
         param->table->s->primary_key)
     {
       cpk_scan= cur_child;
@@ -1368,7 +1371,7 @@
     {
       /* Ok, we have index_only cost, now get full rows scan cost */
       cost= param->table->cursor->
-              read_time(param->real_keynr[(*cur_child)->key_idx], 1,
+              read_time(param->real_keynr[(*cur_child)->getKeyIndex()], 1,
                         (*cur_child)->records) +
               rows2double((*cur_child)->records) / TIME_FOR_COMPARE;
     }
@@ -1386,8 +1389,10 @@
       roru_index_costs += (*cur_roru_plan)->read_cost;
     }
     else
+    {
       roru_index_costs +=
-        ((optimizer::RorIntersectReadPlan*)(*cur_roru_plan))->index_scan_costs;
+        ((optimizer::RorIntersectReadPlan *)(*cur_roru_plan))->getCostOfIndexScans();
+    }
     roru_total_records += (*cur_roru_plan)->records;
     roru_intersect_part *= (*cur_roru_plan)->records /
                            param->table->cursor->stats.records;
@@ -1427,8 +1432,7 @@
   {
     if ((roru= new (param->mem_root) optimizer::RorUnionReadPlan))
     {
-      roru->first_ror= roru_read_plans;
-      roru->last_ror= roru_read_plans + n_child_scans;
+      roru->merged_scans.assign(roru_read_plans, roru_read_plans + n_child_scans);
       roru->read_cost= roru_total_cost;
       roru->records= roru_total_records;
       return roru;
@@ -2087,13 +2091,8 @@
     if (! (trp= new (param->mem_root) optimizer::RorIntersectReadPlan))
       return trp;
 
-    if (! (trp->first_scan=
-           (ROR_SCAN_INFO**)alloc_root(param->mem_root,
-                                       sizeof(ROR_SCAN_INFO*)*best_num)))
-      return NULL;
-    memcpy(trp->first_scan, intersect_scans, best_num*sizeof(ROR_SCAN_INFO*));
-    trp->last_scan=  trp->first_scan + best_num;
-    trp->is_covering= intersect_best->is_covering;
+    trp->ror_range_scans.assign(intersect_scans, intersect_scans + best_num);
+    trp->setRowRetrievalNecessary(intersect_best->is_covering);
     trp->read_cost= intersect_best->total_cost;
     /* Prevent divisons by zero */
     ha_rows best_rows = double2rows(intersect_best->out_rows);
@@ -2101,7 +2100,7 @@
       best_rows= 1;
     set_if_smaller(param->table->quick_condition_rows, best_rows);
     trp->records= best_rows;
-    trp->index_scan_costs= intersect_best->index_scan_costs;
+    trp->setCostOfIndexScans(intersect_best->index_scan_costs);
     trp->cpk_scan= cpk_scan_used? cpk_scan: NULL;
   }
   return(trp);
@@ -2242,13 +2241,8 @@
   }
 
   uint32_t best_num= (ror_scan_mark - tree->ror_scans);
-  if (!(trp->first_scan= (ROR_SCAN_INFO**)alloc_root(param->mem_root,
-                                                     sizeof(ROR_SCAN_INFO*)*
-                                                     best_num)))
-    return NULL;
-  memcpy(trp->first_scan, tree->ror_scans, best_num*sizeof(ROR_SCAN_INFO*));
-  trp->last_scan=  trp->first_scan + best_num;
-  trp->is_covering= true;
+  trp->ror_range_scans.assign(tree->ror_scans, tree->ror_scans + best_num);
+  trp->setRowRetrievalNecessary(true);
   trp->read_cost= total_cost;
   trp->records= records;
   trp->cpk_scan= NULL;
@@ -2352,7 +2346,7 @@
       read_plan->records= best_records;
       read_plan->is_ror= tree->ror_scans_map.test(idx);
       read_plan->read_cost= read_time;
-      read_plan->mrr_buf_size= best_buf_size;
+      read_plan->setMRRBufferSize(best_buf_size);
     }
   }
 
@@ -2402,16 +2396,17 @@
                                                 (retrieve_full_rows? (! is_covering) : false),
                                                 parent_alloc)))
   {
-    print_ror_scans_arr(param->table,
-                        "creating ROR-intersect",
-                        first_scan,
-                        last_scan);
+    print_ror_scans_vector(param->table,
+                           "creating ROR-intersect",
+                           ror_range_scans);
     alloc= parent_alloc ? parent_alloc : &quick_intersect->alloc;
-    for (; first_scan != last_scan; ++first_scan)
+    for (vector<struct st_ror_scan_info *>::iterator it= ror_range_scans.begin();
+         it != ror_range_scans.end();
+         ++it)
     {
       if (! (quick= optimizer::get_quick_select(param,
-                                                (*first_scan)->idx,
-                                                (*first_scan)->sel_arg,
+                                                (*it)->idx,
+                                                (*it)->sel_arg,
                                                 HA_MRR_USE_DEFAULT_IMPL | HA_MRR_SORTED,
                                                 0,
                                                 alloc)) ||
@@ -2446,7 +2441,6 @@
 optimizer::QuickSelectInterface *optimizer::RorUnionReadPlan::make_quick(optimizer::Parameter *param, bool, memory::Root *)
 {
   optimizer::QuickRorUnionSelect *quick_roru= NULL;
-  optimizer::TableReadPlan **scan= NULL;
   optimizer::QuickSelectInterface *quick= NULL;
   /*
     It is impossible to construct a ROR-union that will not retrieve full
@@ -2454,9 +2448,11 @@
   */
   if ((quick_roru= new optimizer::QuickRorUnionSelect(param->session, param->table)))
   {
-    for (scan= first_ror; scan != last_ror; scan++)
+    for (vector<optimizer::TableReadPlan *>::iterator it= merged_scans.begin();
+         it != merged_scans.end();
+         ++it)
     {
-      if (! (quick= (*scan)->make_quick(param, false, &quick_roru->alloc)) ||
+      if (! (quick= (*it)->make_quick(param, false, &quick_roru->alloc)) ||
           quick_roru->push_quick_back(quick))
       {
         return NULL;
@@ -6408,4 +6404,23 @@
     tmp.append(STRING_WITH_LEN("(empty)"));
 }
 
+static void print_ror_scans_vector(Table *table,
+                                   const char *,
+                                   vector<struct st_ror_scan_info *> &vec)
+{
+  char buff[1024];
+  String tmp(buff,sizeof(buff),&my_charset_bin);
+  tmp.length(0);
+  for (vector<struct st_ror_scan_info *>::iterator it= vec.begin();
+       it != vec.end();
+       ++it)
+  {
+    if (tmp.length())
+      tmp.append(',');
+    tmp.append(table->key_info[(*it)->keynr].name);
+  }
+  if (! tmp.length())
+    tmp.append(STRING_WITH_LEN("(empty)"));
+}
+
 } /* namespace drizzled */

=== modified file 'drizzled/optimizer/sel_arg.h'
--- drizzled/optimizer/sel_arg.h	2010-02-04 08:14:46 +0000
+++ drizzled/optimizer/sel_arg.h	2010-02-10 20:29:17 +0000
@@ -201,7 +201,9 @@
 class SEL_ARG :public memory::SqlAlloc
 {
 public:
-  uint8_t min_flag,max_flag,maybe_flag;
+  uint8_t min_flag;
+  uint8_t max_flag;
+  uint8_t maybe_flag;
   uint8_t part;					// Which key part
   uint8_t maybe_null;
   /*
@@ -226,8 +228,20 @@
   SEL_ARG *next,*prev;    /* Links for bi-directional interval list */
   SEL_ARG *parent;        /* R-B tree parent */
   SEL_ARG *next_key_part;
-  enum leaf_color { BLACK,RED } color;
-  enum Type { IMPOSSIBLE, MAYBE, MAYBE_KEY, KEY_RANGE } type;
+
+  enum leaf_color 
+  { 
+    BLACK,
+    RED 
+  } color;
+
+  enum Type 
+  { 
+    IMPOSSIBLE, 
+    MAYBE, 
+    MAYBE_KEY, 
+    KEY_RANGE 
+  } type;
 
   enum 
   { 

=== modified file 'drizzled/optimizer/table_read_plan.h'
--- drizzled/optimizer/table_read_plan.h	2010-02-04 08:14:46 +0000
+++ drizzled/optimizer/table_read_plan.h	2010-02-10 20:00:52 +0000
@@ -100,21 +100,42 @@
 
 public:
 
-  SEL_ARG *key; /* set of intervals to be used in "range" method retrieval */
-  uint32_t     key_idx; /* key number in Parameter::key */
-  uint32_t     mrr_flags;
-  uint32_t     mrr_buf_size;
-
   RangeReadPlan(SEL_ARG *key_arg, uint32_t idx_arg, uint32_t mrr_flags_arg)
     :
       key(key_arg),
       key_idx(idx_arg),
-      mrr_flags(mrr_flags_arg)
+      mrr_flags(mrr_flags_arg),
+      mrr_buf_size(0)
   {}
+
   virtual ~RangeReadPlan() {}                     /* Remove gcc warning */
 
   QuickSelectInterface *make_quick(Parameter *param, bool, memory::Root *parent_alloc);
 
+  void setMRRBufferSize(uint32_t in_mrr_buf_size)
+  {
+    mrr_buf_size= in_mrr_buf_size;
+  }
+
+  uint32_t getKeyIndex() const
+  {
+    return key_idx;
+  }
+
+  uint32_t getMRRBufferSize() const
+  {
+    return mrr_buf_size;
+  }
+
+private:
+
+  /** set of intervals to be used in "range" method retrieval */
+  SEL_ARG *key;
+  /** key number in Parameter::key */
+  uint32_t     key_idx;
+  uint32_t     mrr_flags;
+  uint32_t     mrr_buf_size;
+
 };
 
 
@@ -122,18 +143,58 @@
 class RorIntersectReadPlan : public TableReadPlan
 {
 public:
-  RorIntersectReadPlan() {}                      /* Remove gcc warning */
+
+  RorIntersectReadPlan() 
+    :
+      ror_range_scans(),
+      cpk_scan(NULL),
+      is_covering(false),
+      index_scan_costs(0.0)
+  {}
+
   virtual ~RorIntersectReadPlan() {}             /* Remove gcc warning */
+
   QuickSelectInterface *make_quick(Parameter *param,
                                    bool retrieve_full_rows,
                                    memory::Root *parent_alloc);
 
-  /* Array of pointers to ROR range scans used in this intersection */
-  struct st_ror_scan_info **first_scan;
-  struct st_ror_scan_info **last_scan; /* End of the above array */
+  void setRowRetrievalNecessary(bool in_is_covering)
+  {
+    is_covering= in_is_covering;
+  }
+
+  void setCostOfIndexScans(double in_index_scan_costs)
+  {
+    index_scan_costs= in_index_scan_costs;
+  }
+
+  /**
+   * @return true if row retrival phase is necessary.
+   */
+  bool isRowRetrievalNecessary() const
+  {
+    return ! is_covering;
+  }
+
+  /**
+   * @return the sum of the cost of each index scan
+   */
+  double getCostOfIndexScans() const
+  {
+    return index_scan_costs;
+  }
+
+  /** Vector of pointers to ROR range scans used in this intersection */
+  std::vector<struct st_ror_scan_info *> ror_range_scans;
   struct st_ror_scan_info *cpk_scan;  /* Clustered PK scan, if there is one */
-  bool is_covering; /* true if no row retrieval phase is necessary */
-  double index_scan_costs; /* SUM(cost(index_scan)) */
+
+private:
+
+  /** true if no row retrieval phase is necessary */
+  bool is_covering; 
+  /* SUM(cost(index_scan)) */
+  double index_scan_costs; 
+
 };
 
 
@@ -151,8 +212,8 @@
   QuickSelectInterface *make_quick(Parameter *param,
                                    bool retrieve_full_rows,
                                    memory::Root *parent_alloc);
-  TableReadPlan **first_ror; /* array of ptrs to plans for merged scans */
-  TableReadPlan **last_ror;  /* end of the above array */
+  /** vector of plans for merged scans */
+  std::vector<TableReadPlan *> merged_scans;
 };
 
 
@@ -181,25 +242,9 @@
 
 class GroupMinMaxReadPlan : public TableReadPlan
 {
-private:
-  bool have_min;
-  bool have_max;
-  KEY_PART_INFO *min_max_arg_part;
-  uint32_t group_prefix_len;
-  uint32_t used_key_parts;
-  uint32_t group_key_parts;
-  KEY *index_info;
-  uint32_t index;
-  uint32_t key_infix_len;
-  unsigned char key_infix[MAX_KEY_LENGTH];
-  SEL_TREE *range_tree; /* Represents all range predicates in the query. */
-  SEL_ARG *index_tree; /* The SEL_ARG sub-tree corresponding to index_info. */
-  uint32_t param_idx; /* Index of used key in param->key. */
-  /* Number of records selected by the ranges in index_tree. */
-public:
-  ha_rows quick_prefix_records;
-
-public:
+
+public:
+
   GroupMinMaxReadPlan(bool have_min_arg, 
                       bool have_max_arg,
                       KEY_PART_INFO *min_max_arg_part_arg,
@@ -215,6 +260,7 @@
                       uint32_t param_idx_arg, 
                       ha_rows quick_prefix_records_arg)
     :
+      quick_prefix_records(quick_prefix_records_arg),
       have_min(have_min_arg),
       have_max(have_max_arg),
       min_max_arg_part(min_max_arg_part_arg),
@@ -226,8 +272,7 @@
       key_infix_len(key_infix_len_arg),
       range_tree(tree_arg),
       index_tree(index_tree_arg),
-      param_idx(param_idx_arg),
-      quick_prefix_records(quick_prefix_records_arg)
+      param_idx(param_idx_arg)
     {
       if (key_infix_len)
         memcpy(this->key_infix, key_infix_arg, key_infix_len);
@@ -237,6 +282,25 @@
   QuickSelectInterface *make_quick(Parameter *param,
                                    bool retrieve_full_rows,
                                    memory::Root *parent_alloc);
+
+  /* Number of records selected by the ranges in index_tree. */
+  ha_rows quick_prefix_records;
+
+private:
+
+  bool have_min;
+  bool have_max;
+  KEY_PART_INFO *min_max_arg_part;
+  uint32_t group_prefix_len;
+  uint32_t used_key_parts;
+  uint32_t group_key_parts;
+  KEY *index_info;
+  uint32_t index;
+  uint32_t key_infix_len;
+  unsigned char key_infix[MAX_KEY_LENGTH];
+  SEL_TREE *range_tree; /* Represents all range predicates in the query. */
+  SEL_ARG *index_tree; /* The SEL_ARG sub-tree corresponding to index_info. */
+  uint32_t param_idx; /* Index of used key in param->key. */
 };
 
 

=== modified file 'drizzled/plugin/loader.cc'
--- drizzled/plugin/loader.cc	2010-02-05 20:19:10 +0000
+++ drizzled/plugin/loader.cc	2010-02-10 19:49:21 +0000
@@ -256,6 +256,16 @@
   /* Find plugin by name */
   const plugin::Manifest *manifest= library->getManifest();
 
+  if (registry.find(manifest->name))
+  {
+    errmsg_printf(ERRMSG_LVL_ERROR, 
+                  _("Plugin '%s' contains the name '%s' in its manifest, which "
+                    "has already been registered.\n"),
+                  library->getName().c_str(),
+                  manifest->name);
+    return true;
+  }
+
   tmp= new (std::nothrow) plugin::Module(manifest, library);
   if (tmp == NULL)
     return true;
@@ -546,7 +556,7 @@
     if (library == NULL)
     {
       errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("Couldn't load plugin library named '%s'."),
+                    _("Couldn't load plugin library named '%s'.\n"),
                     plugin_name.c_str());
       return true;
     }
@@ -556,7 +566,7 @@
     {
       registry.removeLibrary(plugin_name);
       errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("Couldn't load plugin named '%s'."),
+                    _("Couldn't load plugin named '%s'.\n"),
                     plugin_name.c_str());
       return true;
 

=== modified file 'drizzled/security_context.h'
--- drizzled/security_context.h	2010-02-04 08:14:46 +0000
+++ drizzled/security_context.h	2010-02-10 23:50:24 +0000
@@ -25,28 +25,37 @@
 {
 
 /**
-  @class Security_context
+  @class SecurityContext
   @brief A set of Session members describing the current authenticated user.
 */
 
-class Security_context {
+class SecurityContext {
 public:
-  Security_context() {}
-  /*
-    host - host of the client
-    user - user of the client, set to NULL until the user has been read from
-    the connection
-    priv_user - The user privilege we are using. May be "" for anonymous user.
-    ip - client IP
-  */
+  SecurityContext() {}
+
+  const std::string& getIp() const
+  {
+    return ip;
+  }
+
+  void setIp(const char *newip)
+  {
+    ip.assign(newip);
+  }
+
+  const std::string& getUser() const
+  {
+    return user;
+  }
+
+  void setUser(const char *newuser)
+  {
+    user.assign(newuser);
+  }
+
+private:
   std::string user;
   std::string ip;
-
-  void skip_grants();
-  inline const char *priv_host_name()
-  {
-    return (ip.c_str() ? ip.c_str() : (char *)"%");
-  }
 };
 
 } /* namespace drizzled */

=== modified file 'drizzled/select_dumpvar.h'
--- drizzled/select_dumpvar.h	2010-02-04 08:14:46 +0000
+++ drizzled/select_dumpvar.h	2010-02-11 01:35:55 +0000
@@ -21,7 +21,7 @@
 #define DRIZZLED_SELECT_DUMPVAR_H
 
 #include "drizzled/error.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #include <vector>
 

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-02-11 20:01:37 +0000
+++ drizzled/session.cc	2010-02-13 01:41:44 +0000
@@ -25,7 +25,6 @@
 #include <drizzled/session.h>
 #include "drizzled/session_list.h"
 #include <sys/stat.h>
-#include "drizzled/my_error.h"
 #include <drizzled/error.h>
 #include <drizzled/gettext.h>
 #include <drizzled/query_id.h>
@@ -391,8 +390,8 @@
     if (global_system_variables.log_warnings)
         errmsg_printf(ERRMSG_LVL_WARN, ER(ER_FORCING_CLOSE),internal::my_progname,
                       thread_id,
-                      (security_ctx.user.c_str() ?
-                       security_ctx.user.c_str() : ""));
+                      (getSecurityContext().getUser().c_str() ?
+                       getSecurityContext().getUser().c_str() : ""));
     disconnect(0, false);
   }
 
@@ -677,7 +676,7 @@
 
   if (passwd_len != 0 && passwd_len != SCRAMBLE_LENGTH)
   {
-    my_error(ER_HANDSHAKE_ERROR, MYF(0), security_ctx.ip.c_str());
+    my_error(ER_HANDSHAKE_ERROR, MYF(0), getSecurityContext().getIp().c_str());
     return false;
   }
 
@@ -686,15 +685,13 @@
   if (is_authenticated != true)
   {
     my_error(ER_ACCESS_DENIED_ERROR, MYF(0),
-             security_ctx.user.c_str(),
-             security_ctx.ip.c_str(),
+             getSecurityContext().getUser().c_str(),
+             getSecurityContext().getIp().c_str(),
              passwd_len ? ER(ER_YES) : ER(ER_NO));
 
     return false;
   }
 
-  security_ctx.skip_grants();
-
   /* Change database if necessary */
   if (in_db && in_db[0])
   {
@@ -1606,11 +1603,6 @@
   memset(&status_var, 0, sizeof(status_var));
 }
 
-void Security_context::skip_grants()
-{
-  /* privileges for the user are unknown everything is allowed */
-}
-
 
 /****************************************************************************
   Handling of open and locked tables states.
@@ -1719,13 +1711,13 @@
   {
     if (! killed && variables.log_warnings > 1)
     {
-      Security_context *sctx= &security_ctx;
+      SecurityContext *sctx= &security_ctx;
 
       errmsg_printf(ERRMSG_LVL_WARN, ER(ER_NEW_ABORTING_CONNECTION)
                   , thread_id
                   , (db.empty() ? "unconnected" : db.c_str())
-                  , sctx->user.empty() == false ? sctx->user.c_str() : "unauthenticated"
-                  , sctx->ip.c_str()
+                  , sctx->getUser().empty() == false ? sctx->getUser().c_str() : "unauthenticated"
+                  , sctx->getIp().c_str()
                   , (main_da.is_error() ? main_da.message() : ER(ER_UNKNOWN_ERROR)));
     }
   }

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2010-02-11 03:29:52 +0000
+++ drizzled/session.h	2010-02-13 01:41:44 +0000
@@ -457,19 +457,18 @@
    */
   char *thread_stack;
 
-  /**
-    @note
-    Some members of Session (currently 'Statement::db',
-    'query')  are set and alloced by the slave SQL thread
-    (for the Session of that thread); that thread is (and must remain, for now)
-    the only responsible for freeing these 3 members. If you add members
-    here, and you add code to set them in replication, don't forget to
-    free_them_and_set_them_to_0 in replication properly. For details see
-    the 'err:' label of the handle_slave_sql() in sql/slave.cc.
+private:
+  SecurityContext security_ctx;
+public:
+  const SecurityContext& getSecurityContext() const
+  {
+    return security_ctx;
+  }
 
-    @see handle_slave_sql
-  */
-  Security_context security_ctx;
+  SecurityContext& getSecurityContext()
+  {
+    return security_ctx;
+  }
 
   /**
     Used in error messages to tell user in what part of MySQL we found an

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2010-02-04 08:14:46 +0000
+++ drizzled/show.cc	2010-02-10 23:50:24 +0000
@@ -708,7 +708,12 @@
   uint64_t thread_id;
   time_t start_time;
   uint32_t   command;
-  string user, host, db, proc_info, state_info, query;
+  string user;
+  string host;
+  string db;
+  string proc_info;
+  string state_info;
+  string query;
   thread_info(uint64_t thread_id_arg,
               time_t start_time_arg,
               uint32_t command_arg,
@@ -724,7 +729,7 @@
   {}
 };
 
-void mysqld_list_processes(Session *session,const char *user, bool)
+void mysqld_list_processes(Session *session, const char *user, bool)
 {
   Item *field;
   List<Item> field_list;
@@ -751,9 +756,9 @@
     for(vector<Session*>::iterator it= getSessionList().begin(); it != getSessionList().end(); ++it)
     {
       tmp= *it;
-      Security_context *tmp_sctx= &tmp->security_ctx;
+      const SecurityContext *tmp_sctx= &tmp->getSecurityContext();
       internal::st_my_thread_var *mysys_var;
-      if (tmp->client->isConnected() && (!user || (tmp_sctx->user.c_str() && !strcmp(tmp_sctx->user.c_str(), user))))
+      if (tmp->client->isConnected() && (not user || (not tmp_sctx->getUser().compare(user))))
       {
 
         if ((mysys_var= tmp->mysys_var))
@@ -779,10 +784,10 @@
         thread_infos.push_back(thread_info(tmp->thread_id,
                                            tmp->start_time,
                                            tmp->command,
-                                           tmp_sctx->user.empty()
+                                           tmp_sctx->getUser().empty()
                                              ? string("unauthenticated user")
-                                             : tmp_sctx->user,
-                                           tmp_sctx->ip,
+                                             : tmp_sctx->getUser(),
+                                           tmp_sctx->getIp(),
                                            tmp->db,
                                            tmp_proc_info,
                                            tmp_state_info,

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2010-02-11 20:01:37 +0000
+++ drizzled/sql_parse.cc	2010-02-13 01:41:44 +0000
@@ -66,7 +66,7 @@
 /* Prototypes */
 bool my_yyoverflow(short **a, YYSTYPE **b, ulong *yystacksize);
 static bool parse_sql(Session *session, Lex_input_stream *lip);
-static void mysql_parse(Session *session, const char *inBuf, uint32_t length);
+void mysql_parse(Session *session, const char *inBuf, uint32_t length);
 
 /**
   @defgroup Runtime_Environment Runtime Environment
@@ -738,7 +738,7 @@
   @param       length  Length of the query text
 */
 
-static void mysql_parse(Session *session, const char *inBuf, uint32_t length)
+void mysql_parse(Session *session, const char *inBuf, uint32_t length)
 {
   lex_start(session);
   session->reset_for_next_command();

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2010-02-05 05:07:14 +0000
+++ drizzled/table.cc	2010-02-10 23:07:02 +0000
@@ -2370,16 +2370,11 @@
 #define AVG_STRING_LENGTH_TO_PACK_ROWS   64
 #define RATIO_TO_PACK_ROWS	       2
 
-static void make_internal_temporary_table_path(Session *session, char* path)
+static void make_internal_temporary_table_path(Session *session, char *path)
 {
-  /* if we run out of slots or we are not using tempool */
   snprintf(path, FN_REFLEN, "%s%lx_%"PRIx64"_%x", TMP_FILE_PREFIX, (unsigned long)current_pid,
            session->thread_id, session->tmp_table++);
 
-  /*
-    No need to change table name to lower case as we are only creating
-    MyISAM or HEAP tables here
-  */
   internal::fn_format(path, path, drizzle_tmpdir, "", MY_REPLACE_EXT|MY_UNPACK_FILENAME);
 }
 
@@ -2401,7 +2396,8 @@
   bool  using_unique_constraint= false;
   bool  use_packed_rows= true;
   bool  not_all_columns= !(select_options & TMP_TABLE_ALL_COLUMNS);
-  char  *tmpname,path[FN_REFLEN];
+  char  *tmpname;
+  char  path[FN_REFLEN];
   unsigned char	*pos, *group_buff, *bitmaps;
   unsigned char *null_flags;
   Field **reg_field, **from_field, **default_field;

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2010-02-05 04:04:52 +0000
+++ drizzled/table.h	2010-02-10 23:50:24 +0000
@@ -44,7 +44,7 @@
 class Select_Lex_Unit;
 class Select_Lex;
 class COND_EQUAL;
-class Security_context;
+class SecurityContext;
 class TableList;
 class Field_timestamp;
 class Field_blob;

=== modified file 'm4/pandora_canonical.m4'
--- m4/pandora_canonical.m4	2010-01-13 08:23:59 +0000
+++ m4/pandora_canonical.m4	2010-02-12 20:34:15 +0000
@@ -4,7 +4,7 @@
 dnl with or without modifications, as long as this notice is preserved.
 
 dnl Which version of the canonical setup we're using
-AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.95])
+AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.108])
 
 AC_DEFUN([PANDORA_FORCE_DEPEND_TRACKING],[
   AC_ARG_ENABLE([fat-binaries],
@@ -29,27 +29,17 @@
   ifdef([m4_define],,[define([m4_define],   defn([define]))])
   ifdef([m4_undefine],,[define([m4_undefine],   defn([undefine]))])
   m4_define([PCT_ALL_ARGS],[$*])
-  m4_define([PCT_USE_GNULIB],[no])
   m4_define([PCT_REQUIRE_CXX],[no])
-  m4_define([PCT_IGNORE_SHARED_PTR],[no])
   m4_define([PCT_FORCE_GCC42],[no])
-  m4_define([PCT_SRC_IN_SRC],[no])
+  m4_define([PCT_DONT_SUPPRESS_INCLUDE],[no])
   m4_define([PCT_VERSION_FROM_VC],[no])
   m4_define([PCT_USE_VISIBILITY],[yes])
   m4_foreach([pct_arg],[$*],[
     m4_case(pct_arg,
-      [use-gnulib], [
-        m4_undefine([PCT_USE_GNULIB])
-        m4_define([PCT_USE_GNULIB],[yes])
-      ],
       [require-cxx], [
         m4_undefine([PCT_REQUIRE_CXX])
         m4_define([PCT_REQUIRE_CXX],[yes])
       ],
-      [ignore-shared-ptr], [
-        m4_undefine([PCT_IGNORE_SHARED_PTR])
-        m4_define([PCT_IGNORE_SHARED_PTR],[yes])
-      ],
       [force-gcc42], [
         m4_undefine([PCT_FORCE_GCC42])
         m4_define([PCT_FORCE_GCC42],[yes])
@@ -58,9 +48,9 @@
         m4_undefine([PCT_USE_VISIBILITY])
         m4_define([PCT_USE_VISIBILITY],[no])
       ],
-      [src-in-src], [
-        m4_undefine([PCT_SRC_IN_SRC])
-        m4_define([PCT_SRC_IN_SRC],[yes])
+      [dont-suppress-include], [
+        m4_undefine([PCT_DONT_SUPPRESS_INCLUDE])
+        m4_define([PCT_DONT_SUPPRESS_INCLUDE],[yes])
       ],
       [version-from-vc], [
         m4_undefine([PCT_VERSION_FROM_VC])
@@ -68,6 +58,14 @@
     ])
   ])
 
+  AC_CONFIG_MACRO_DIR([m4])
+
+  m4_if(m4_substr(m4_esyscmd(test -d src && echo 0),0,1),0,[
+    AC_CONFIG_HEADERS([src/config.h])
+  ],[
+    AC_CONFIG_HEADERS([config.h])
+  ])
+
   # We need to prevent canonical target
   # from injecting -O2 into CFLAGS - but we won't modify anything if we have
   # set CFLAGS on the command line, since that should take ultimate precedence
@@ -78,10 +76,17 @@
   
   AC_CANONICAL_TARGET
   
-  AM_INIT_AUTOMAKE(-Wall -Werror nostdinc subdir-objects foreign)
+  m4_if(PCT_DONT_SUPRESS_INCLUDE,yes,[
+    AM_INIT_AUTOMAKE(-Wall -Werror subdir-objects foreign)
+  ],[
+    AM_INIT_AUTOMAKE(-Wall -Werror nostdinc subdir-objects foreign)
+  ])
+
   m4_ifdef([AM_SILENT_RULES],[AM_SILENT_RULES([yes])])
 
-  m4_if(PCT_USE_GNULIB,yes,[ gl_EARLY ])
+  m4_if(m4_substr(m4_esyscmd(test -d gnulib && echo 0),0,1),0,[
+    gl_EARLY
+  ])
   
   AC_REQUIRE([AC_PROG_CC])
   AC_REQUIRE([PANDORA_MAC_GCC42])
@@ -118,14 +123,7 @@
 
   ])
   
-  PANDORA_SHARED_PTR
-  m4_if(PCT_IGNORE_SHARED_PTR, [no], [
-    AS_IF([test "$ac_cv_shared_ptr_namespace" = "missing"],[
-      AC_MSG_WARN([a usable shared_ptr implementation was not found. Let someone know what your platform is.])
-    ])
-  ])
-  
-  m4_if(PCT_USE_GNULIB, [yes], [
+  m4_if(m4_substr(m4_esyscmd(test -d gnulib && echo 0),0,1),0,[
     gl_INIT
     AC_CONFIG_LIBOBJ_DIR([gnulib])
   ])
@@ -140,8 +138,10 @@
   AC_C_RESTRICT
 
   AC_HEADER_TIME
+  AC_STRUCT_TM
   AC_TYPE_SIZE_T
   AC_SYS_LARGEFILE
+  PANDORA_CLOCK_GETTIME
 
   # off_t is not a builtin type
   AC_CHECK_SIZEOF(off_t, 4)
@@ -175,10 +175,6 @@
     AC_DEFINE([TIME_T_UNSIGNED], 1, [Define to 1 if time_t is unsigned])
   ])
 
-  dnl AC_FUNC_ALLOCA would test for stack direction if we didn't have a working
-  dnl alloca - but we need to know it anyway for check_stack_overrun.
-  PANDORA_STACK_DIRECTION
-
   AC_CHECK_LIBM
   
   AC_CHECK_FUNC(setsockopt, [], [AC_CHECK_LIB(socket, setsockopt)])
@@ -220,22 +216,28 @@
 
   AC_CHECK_PROGS([DOXYGEN], [doxygen])
   AC_CHECK_PROGS([PERL], [perl])
+  AC_CHECK_PROGS([DPKG_GENSYMBOLS], [dpkg-gensymbols], [:])
+
+  AM_CONDITIONAL(HAVE_DPKG_GENSYMBOLS,[test "x${DPKG_GENSYMBOLS}" != "x:"])
+
+  PANDORA_WITH_GETTEXT
 
   AS_IF([test "x${gl_LIBOBJS}" != "x"],[
     AS_IF([test "$GCC" = "yes"],[
-      AM_CPPFLAGS="-isystem \$(top_srcdir)/gnulib -isystem \$(top_builddir)/gnulib ${AM_CPPFLAGS}"
+      AM_CPPFLAGS="-isystem \${top_srcdir}/gnulib -isystem \${top_builddir}/gnulib ${AM_CPPFLAGS}"
     ],[
-    AM_CPPFLAGS="-I\$(top_srcdir)/gnulib -I\$(top_builddir)/gnulib ${AM_CPPFLAGS}"
+    AM_CPPFLAGS="-I\${top_srcdir}/gnulib -I\${top_builddir}/gnulib ${AM_CPPFLAGS}"
     ])
   ])
-  AS_IF([test "PCT_SRC_IN_SRC" = "yes"],[
+  m4_if(m4_substr(m4_esyscmd(test -d src && echo 0),0,1),0,[
     AM_CPPFLAGS="-I\$(top_srcdir)/src -I\$(top_builddir)/src ${AM_CPPFLAGS}"
+  ],[
+    AM_CPPFLAGS="-I\$(top_srcdir) -I\$(top_builddir) ${AM_CPPFLAGS}"
   ])
 
   PANDORA_USE_PIPE
 
 
-  AM_CPPFLAGS="-I\${top_srcdir} -I\${top_builddir} ${AM_CPPFLAGS}"
   AM_CFLAGS="${AM_CFLAGS} ${CC_WARNINGS} ${CC_PROFILING} ${CC_COVERAGE}"
   AM_CXXFLAGS="${AM_CXXFLAGS} ${CXX_WARNINGS} ${CC_PROFILING} ${CC_COVERAGE}"
 

=== added file 'm4/pandora_clock_gettime.m4'
--- m4/pandora_clock_gettime.m4	1970-01-01 00:00:00 +0000
+++ m4/pandora_clock_gettime.m4	2010-02-03 01:42:59 +0000
@@ -0,0 +1,15 @@
+dnl Copyright (C) 2010 Monty Taylor
+dnl This file is free software; Monty Taylor
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
+#--------------------------------------------------------------------
+# Check for clock_gettime
+#--------------------------------------------------------------------
+
+AC_DEFUN([PANDORA_CLOCK_GETTIME],[
+  AC_SEARCH_LIBS([clock_gettime],[rt])
+  AS_IF([test "x${ac_cv_search_clock_gettime}" != "xno"],[
+    AC_DEFINE([HAVE_CLOCK_GETTIME],[1],[Have a working clock_gettime function])
+  ])
+])

=== modified file 'm4/pandora_fdatasync.m4'
--- m4/pandora_fdatasync.m4	2009-11-18 01:39:00 +0000
+++ m4/pandora_fdatasync.m4	2010-02-01 23:38:13 +0000
@@ -11,7 +11,7 @@
 AC_DEFUN([PANDORA_WORKING_FDATASYNC],[
   AC_CACHE_CHECK([working fdatasync],[ac_cv_func_fdatasync],[
     AC_LANG_PUSH(C++)
-    AC_RUN_IFELSE([AC_LANG_PROGRAM([[
+    AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
 #include <unistd.h>
       ]],[[
 fdatasync(4);
@@ -22,4 +22,4 @@
   ])
   AS_IF([test "x${ac_cv_func_fdatasync}" = "xyes"],
     [AC_DEFINE([HAVE_FDATASYNC],[1],[If the system has a working fdatasync])])
-])
\ No newline at end of file
+])

=== modified file 'm4/pandora_have_gcc_atomics.m4'
--- m4/pandora_have_gcc_atomics.m4	2009-11-18 01:39:00 +0000
+++ m4/pandora_have_gcc_atomics.m4	2010-02-01 23:38:13 +0000
@@ -13,7 +13,7 @@
   AC_CACHE_CHECK(
     [whether the compiler provides atomic builtins],
     [ac_cv_gcc_atomic_builtins],
-    [AC_RUN_IFELSE(
+    [AC_LINK_IFELSE(
       [AC_LANG_PROGRAM([],[[
         int foo= -10; int bar= 10;
         if (!__sync_fetch_and_add(&foo, bar) || foo)
@@ -34,4 +34,4 @@
               [Define to 1 if compiler provides atomic builtins.])
   ])
 
-])
\ No newline at end of file
+])

=== modified file 'm4/pandora_have_libmemcached.m4'
--- m4/pandora_have_libmemcached.m4	2010-01-13 08:23:59 +0000
+++ m4/pandora_have_libmemcached.m4	2010-01-26 00:57:12 +0000
@@ -32,6 +32,7 @@
     ])
   ],[
     ac_cv_libmemcached="no"
+    ac_cv_libmemcachedprotocol="no"
   ])
   
   AC_CACHE_CHECK([if libmemcached has memcached_server_fn],
@@ -60,3 +61,8 @@
       AC_MSG_ERROR([libmemcached is required for ${PACKAGE}]))
 ])
 
+AC_DEFUN([PANDORA_REQUIRE_LIBMEMCACHEDPROTOCOL],[
+  AC_REQUIRE([PANDORA_HAVE_LIBMEMCACHED])
+  AS_IF([test x$ac_cv_libmemcachedprotocol = xno],
+      AC_MSG_ERROR([libmemcachedprotocol is required for ${PACKAGE}]))
+])

=== added file 'm4/pandora_have_libmysqlclient.m4'
--- m4/pandora_have_libmysqlclient.m4	1970-01-01 00:00:00 +0000
+++ m4/pandora_have_libmysqlclient.m4	2010-01-26 00:57:12 +0000
@@ -0,0 +1,146 @@
+dnl -*- mode: m4; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+dnl vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+dnl
+dnl  Copyright (C) 2010 Monty Taylor
+dnl  This file is free software; Sun Microsystems
+dnl  gives unlimited permission to copy and/or distribute it,
+dnl  with or without modifications, as long as this notice is preserved.
+dnl
+
+AC_DEFUN([PANDORA_WITH_MYSQL],[
+  AC_ARG_WITH([mysql],
+    [AS_HELP_STRING([--with-mysql=PATH],
+        [path to mysql_config binary or mysql prefix dir])], 
+      [with_mysql=$withval],
+      [with_mysql=":"])
+
+  dnl There are three possibilities:
+  dnl   1) nothing is given: we will search for mysql_config in PATH
+  dnl   2) the location of mysql_config is given: we'll use that to determine
+  dnl   3) a directory argument is given: that will be mysql_base
+
+     
+  dnl option 1: nothing, we need to insert something into MYSQL_CONFIG
+  AS_IF([test "x$with_mysql" = "x:"],[
+    AC_CHECK_PROGS(MYSQL_CONFIG,[mysql_config])
+  ],[
+    MYSQL_CONFIG="${with_mysql}"
+  ])
+
+  AC_CACHE_CHECK([for MySQL Base Location],[pandora_cv_mysql_base],[
+
+    dnl option 2: something in MYSQL_CONFIG now, use that to get a base dir
+    AS_IF([test -f "${MYSQL_CONFIG}" -a -x "${MYSQL_CONFIG}"],[
+      pandora_cv_mysql_base=$(dirname $(MYSQL_CONFIG --include | sed 's/-I//'))
+    ],[
+      dnl option 1: a directory
+      AS_IF([test -d $with_mysql],[pandora_cv_mysql_base=$with_mysql],[
+        pandora_cv_mysql_base="not found"
+      ])
+    ])
+  ])
+])
+
+AC_DEFUN([_PANDORA_SEARCH_LIBMYSQLCLIENT],[
+  AC_REQUIRE([AC_LIB_PREFIX])
+
+  AC_ARG_ENABLE([libmysqlclient],
+    [AS_HELP_STRING([--disable-libmysqlclient],
+      [Build with libmysqlclient support @<:@default=on@:>@])],
+    [ac_enable_libmysqlclient="$enableval"],
+    [ac_enable_libmysqlclient="yes"])
+
+  AS_IF([test "x$ac_enable_libmysqlclient" = "xyes"],[
+    AC_LIB_HAVE_LINKFLAGS(mysqlclient_r,,[
+#include <mysql/mysql.h>
+    ],[
+MYSQL mysql;
+  ])],[
+    ac_cv_libmysqlclient_r="no"
+  ])
+
+  AM_CONDITIONAL(HAVE_LIBMYSQLCLIENT, [test "x${ac_cv_libmysqlclient_r}" = "xyes"])
+  
+AC_DEFUN([PANDORA_HAVE_LIBMYSQLCLIENT],[
+  AC_REQUIRE([_PANDORA_SEARCH_LIBMYSQLCLIENT])
+])
+
+AC_DEFUN([PANDORA_REQUIRE_LIBMYSQLCLIENT],[
+  AC_REQUIRE([PANDORA_HAVE_LIBMYSQLCLIENT])
+  AS_IF([test "x${ac_cv_libmysqlclient_r}" = "xno"],
+      AC_MSG_ERROR([libmysqlclient_r is required for ${PACKAGE}]))
+])
+
+  AS_IF([test "x$MYSQL_CONFIG" = "xISDIR"],[
+    IBASE="-I${with_mysql}"
+    MYSQL_CONFIG="${with_mysql}/scripts/mysql_config"
+    ADDIFLAGS="$IBASE/include "
+    ADDIFLAGS="$ADDIFLAGS $IBASE/storage/ndb/include/ndbapi "
+    ADDIFLAGS="$ADDIFLAGS $IBASE/storage/ndb/include/mgmapi "
+    ADDIFLAGS="$ADDIFLAGS $IBASE/storage/ndb/include "
+    LDFLAGS="-L${with_mysql}/storage/ndb/src/.libs -L${with_mysql}/libmysql_r/.libs/ -L${with_mysql}/mysys/.libs -L${with_mysql}/mysys -L${with_mysql}/strings/.libs -L${with_mysql}/strings "
+  ],[
+    IBASE=`$MYSQL_CONFIG --include`
+    ADDIFLAGS=""
+    # add regular MySQL C flags
+    ADDCFLAGS=`$MYSQL_CONFIG --cflags` 
+    # add NdbAPI specific C flags
+    LDFLAGS="$LDFLAGS "`$MYSQL_CONFIG --libs_r | sed 's/-lmysqlclient_r//'`
+    ])
+
+
+    ADDIFLAGS="$ADDIFLAGS $IBASE/storage/ndb"
+    ADDIFLAGS="$ADDIFLAGS $IBASE/storage/ndb/ndbapi"
+    ADDIFLAGS="$ADDIFLAGS $IBASE/storage/ndb/mgmapi"
+    ADDIFLAGS="$ADDIFLAGS $IBASE/ndb"
+    ADDIFLAGS="$ADDIFLAGS $IBASE/ndb/ndbapi"
+    ADDIFLAGS="$ADDIFLAGS $IBASE/ndb/mgmapi"
+    ADDIFLAGS="$ADDIFLAGS $IBASE"
+
+    CFLAGS="$CFLAGS $ADDCFLAGS $ADDIFLAGS"    
+    CXXFLAGS="$CXXFLAGS $ADDCFLAGS $ADDIFLAGS" 
+    MYSQL_INCLUDES="$IBASE $ADDIFLAGS"   
+
+    
+    dnl AC_CHECK_LIB([mysqlclient_r],[safe_mutex_init],,[AC_MSG_ERROR([Can't link against libmysqlclient_r])])
+    dnl First test to see if we can run with only ndbclient
+    AC_CHECK_LIB([ndbclient],[decimal_bin_size],,[dnl else
+      LDFLAGS="$LDFLAGS -lmysys -ldbug"
+      AC_CHECK_LIB([mysqlclient_r],[safe_mutex_init],,)
+      AC_CHECK_LIB([ndbclient],[ndb_init],,[
+        AC_MSG_ERROR([Can't link against libndbclient])])
+      AC_CHECK_LIB([mystrings],[decimal_bin_size],,[
+          AC_MSG_ERROR([Can't find decimal_bin_size])])])
+    AC_MSG_CHECKING(for NdbApi headers)
+     AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <NdbApi.hpp>]], [[int attr=NdbTransaction::Commit; ]])],[ndbapi_found="yes"],[])
+    AS_IF([test "$ndbapi_found" = "yes"], 
+       [AC_MSG_RESULT(found)],
+       [AC_MSG_ERROR([Couldn't find NdbApi.hpp!])])
+    AC_MSG_CHECKING(for NDB_LE_ThreadConfigLoop)
+      AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <mgmapi.h>]], [[int attr=NDB_LE_ThreadConfigLoop; ]])],[have_cge63="yes"],[])
+      AS_IF([test "$have_cge63" = "yes"],
+        [AC_MSG_RESULT(found)
+         HAVE_CGE63="-DCGE63"
+         AC_SUBST(HAVE_CGE63)],
+        [AC_MSG_RESULT(missing)])
+
+    LDFLAGS="$LDFLAGS $LIBS"
+  
+
+    MYSQL_MAJOR_VERSION=`$MYSQL_CONFIG --version | sed -e 's/\.//g' -e 's/-//g' -e 's/[A-Za-z]//g' | cut -c1-2`
+
+    case "$MYSQL_MAJOR_VERSION" in 
+      50) AC_DEFINE(MYSQL_50, [1], [mysql5.0])
+	;;
+      51) AC_DEFINE(MYSQL_51, [1], [mysql5.1])
+        ;;
+      *) echo "Unsupported version of MySQL Detected!"
+        ;;
+     esac
+    
+    AC_SUBST(MYSQL_MAJOR_VERSION)
+    AC_SUBST(MYSQL_CONFIG)
+    
+  
+])
+

=== added file 'm4/pandora_have_libndbclient.m4'
--- m4/pandora_have_libndbclient.m4	1970-01-01 00:00:00 +0000
+++ m4/pandora_have_libndbclient.m4	2010-01-26 00:57:12 +0000
@@ -0,0 +1,80 @@
+dnl -*- mode: m4; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+dnl vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+dnl
+dnl  Copyright (C) 2010 Monty Taylor
+dnl  This file is free software; Sun Microsystems
+dnl  gives unlimited permission to copy and/or distribute it,
+dnl  with or without modifications, as long as this notice is preserved.
+dnl
+
+AC_DEFUN([_PANDORA_SEARCH_LIBNDBCLIENT],[
+
+  AC_REQUIRE([AC_LIB_PREFIX])
+  AC_REQUIRE([PANDORA_WITH_MYSQL])
+
+  AC_ARG_ENABLE([libndbclient],
+    [AS_HELP_STRING([--disable-libndbclient],
+      [Build with libndbclient support @<:@default=on@:>@])],
+    [ac_enable_libndbclient="$enableval"],
+    [ac_enable_libndbclient="yes"])
+
+  AC_ARG_WITH([libndbclient-prefix],
+    [AS_HELP_STRING([--with-libndbclient-prefix],
+      [search for libndbclient in DIR])],
+    [ac_with_libndbclient=${withval}],
+    [ac_with_libndbclient=${pandora_cv_mysql_base}])
+
+  save_LIBS="${LIBS}"
+  LIBS=""
+  save_CPPFLAGS="${CPPFLAGS}"
+  AS_IF([test "x${ac_with_libndbclient}" != "x"],[
+    LIBS="-L${ac_with_libndbclient}/lib/mysql -L${ac_with_libndbclient}/lib"
+    AS_IF([test "$GCC" = "yes"],[
+      ndb_include_prefix="-isystem "
+    ],[
+      ndb_include_prefix="-I"
+    ])
+    CPPFLAGS="${CPPFLAGS} ${ndb_include_prefix}${ac_with_libndbclient}/include ${ndb_include_prefix}${ac_with_libndbclient}/include/mysql ${ndb_include_prefix}${ac_with_libndbclient}/include/mysql/storage/ndb ${ndb_include_prefix}${ac_with_libndbclient}/include/mysql/storage/ndb/ndbapi ${ndb_include_prefix}${ac_with_libndbclient}/include/mysql/storage/ndb/mgmapi"
+  ])
+  LIBS="${LIBS} -lndbclient -lmysqlclient_r"
+
+  AC_CACHE_CHECK([if NdbApi works],[ac_cv_libndbclient],[
+    AC_LANG_PUSH(C++)
+    AC_LINK_IFELSE([
+      AC_LANG_PROGRAM([[
+#include <NdbApi.hpp>
+      ]],[[
+Ndb *ndb;
+ndb_init();
+      ]])
+    ],[
+      ac_cv_libndbclient=yes
+    ],[
+      ac_cv_libndbclient=no
+    ])
+  ])
+  AC_LANG_POP()
+
+  LIBNDBCLIENT="${LIBS}"
+  LTLIBNDBCLIENT="${LIBS}"
+  AC_SUBST([LIBNDBCLIENT])
+  AC_SUBST([LTLIBNDBCLIENT])
+
+  AS_IF([test "x${ac_cv_libndbclient}" = "xno"],[
+    CPPFLAGS="${save_CPPFLAGS}"
+  ])    
+  LIBS="${save_LIBS}"
+  
+  AM_CONDITIONAL(HAVE_LIBNDBCLIENT, [test "x${ac_cv_libndbclient}" = "xyes"])
+])
+  
+AC_DEFUN([PANDORA_HAVE_LIBNDBCLIENT],[
+  AC_REQUIRE([_PANDORA_SEARCH_LIBNDBCLIENT])
+])
+
+AC_DEFUN([PANDORA_REQUIRE_LIBNDBCLIENT],[
+  AC_REQUIRE([PANDORA_HAVE_LIBNDBCLIENT])
+  AS_IF([test "x${ac_cv_libndbclient}" = "xno"],
+      AC_MSG_ERROR([libndbclient is required for ${PACKAGE}]))
+])
+

=== modified file 'm4/pandora_have_libtokyocabinet.m4'
--- m4/pandora_have_libtokyocabinet.m4	2009-11-20 18:01:03 +0000
+++ m4/pandora_have_libtokyocabinet.m4	2010-02-01 23:38:13 +0000
@@ -22,8 +22,10 @@
   AS_IF([test "x$ac_enable_libtokyocabinet" = "xyes"],[
     AC_LIB_HAVE_LINKFLAGS(tokyocabinet,,[
 #include <tcutil.h>
+#include <tcadb.h>
     ],[
 const char *test= tcversion;
+bool ret= tcadboptimize(NULL, "params");
     ])
   ],[
     ac_cv_libtokyocabinet="no"
@@ -31,11 +33,11 @@
 
   AS_IF([test "${ac_cv_libtokyocabinet}" = "no" -a "${ac_enable_libtokyocabinet}" = "yes"],[
 
-    PKG_CHECK_MODULES([LIBTOKYOCABINET], [libtokyocabinet], [
+    PKG_CHECK_MODULES([LIBTOKYOCABINET], [libtokyocabinet >= 1.4.15], [
       ac_cv_libtokyocabinet=yes
       LTLIBTOKYOCABINET=${LIBTOKYOCABINET_LIBS}
       LIBTOKYOCABINET=${LIBTOKYOCABINET_LIBS}
-    ],[])
+    ],[test x = y])
   ])
 
   AM_CONDITIONAL(HAVE_LIBTOKYOCABINET, [test "${ac_cv_libtokyocabinet}" = "yes"])

=== removed file 'm4/pandora_stack_direction.m4'
--- m4/pandora_stack_direction.m4	2009-12-02 02:56:33 +0000
+++ m4/pandora_stack_direction.m4	1970-01-01 00:00:00 +0000
@@ -1,39 +0,0 @@
-dnl  Copyright (C) 2009 Sun Microsystems
-dnl This file is free software; Sun Microsystems
-dnl gives unlimited permission to copy and/or distribute it,
-dnl with or without modifications, as long as this notice is preserved.
-
-#--------------------------------------------------------------------
-# Check what direction the stack runs in
-#--------------------------------------------------------------------
-
-AC_DEFUN([PANDORA_STACK_DIRECTION],[
- AC_REQUIRE([AC_FUNC_ALLOCA])
- AC_CACHE_CHECK([stack direction], [ac_cv_c_stack_direction],[
-  AC_RUN_IFELSE([AC_LANG_PROGRAM([[
-#include <stdlib.h>
- int find_stack_direction ()
- {
-   static char *addr = 0;
-   auto char dummy;
-   if (addr == 0)
-     {
-       addr = &dummy;
-       return find_stack_direction ();
-     }
-   else
-     return (&dummy > addr) ? 1 : -1;
- }
-  ]],[[
-    exit (find_stack_direction() < 0);
-  ]])],[
-   ac_cv_c_stack_direction=1
-  ],[
-   ac_cv_c_stack_direction=-1
-  ])
- ])
- AC_DEFINE_UNQUOTED(STACK_DIRECTION, $ac_cv_c_stack_direction)
-])
-
-
-

=== modified file 'm4/pandora_use_pipe.m4'
--- m4/pandora_use_pipe.m4	2009-09-22 21:56:03 +0000
+++ m4/pandora_use_pipe.m4	2010-02-01 23:38:13 +0000
@@ -16,7 +16,7 @@
 
   AS_IF([test "$GCC" = "yes"],[
     AC_CACHE_CHECK([for working -pipe], [pandora_cv_use_pipe], [
-      AC_RUN_IFELSE([AC_LANG_SOURCE([[
+      AC_COMPILE_IFELSE([AC_LANG_SOURCE([[
 #include <stdio.h>
 
 int main(int argc, char** argv)

=== modified file 'm4/pandora_vc_build.m4'
--- m4/pandora_vc_build.m4	2009-11-10 20:47:10 +0000
+++ m4/pandora_vc_build.m4	2010-01-26 00:57:12 +0000
@@ -3,57 +3,77 @@
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
 
+AC_DEFUN([_PANDORA_BUILDING_FROM_VC],[
+  pandora_building_from_vc=no
+
+  if test -d ".bzr" ; then
+    pandora_building_from_bzr=yes
+    pandora_building_from_vc=yes
+  else
+    pandora_building_from_bzr=no
+  fi
+
+  if test -d ".svn" ; then
+    pandora_building_from_svn=yes
+    pandora_building_from_vc=yes
+  else
+    pandora_building_from_svn=no
+  fi
+
+  if test -d ".hg" ; then
+    pandora_building_from_hg=yes
+    pandora_building_from_vc=yes
+  else
+    pandora_building_from_hg=no
+  fi
+
+  if test -d ".git" ; then
+    pandora_building_from_git=yes
+    pandora_building_from_vc=yes
+  else
+    pandora_building_from_git=no
+  fi
+])
+
 AC_DEFUN([PANDORA_BUILDING_FROM_VC],[
-
-  ac_cv_building_from_vc=no
-
-  AS_IF([test -d "${srcdir}/.bzr"],[
-    ac_cv_building_from_bzr=yes
-    ac_cv_building_from_vc=yes
-    ],[
-    ac_cv_building_from_bzr=no
-  ])
-
-  AS_IF([test -d "${srcdir}/.svn"],[
-    ac_cv_building_from_svn=yes
-    ac_cv_building_from_vc=yes
-    ],[
-    ac_cv_building_from_svn=no
-  ])
-
-  AS_IF([test -d "${srcdir}/.hg"],[
-    ac_cv_building_from_hg=yes
-    ac_cv_building_from_vc=yes
-    ],[
-    ac_cv_building_from_hg=no
-  ])
-
-  AS_IF([test -d "${srcdir}/.git"],[
-    ac_cv_building_from_git=yes
-    ac_cv_building_from_vc=yes
-    ],[
-    ac_cv_building_from_git=no
-  ])
-
-
+  m4_syscmd(_PANDORA_BUILDING_FROM_VC [
+
+    PANDORA_RELEASE_DATE=`date +%Y.%m`
+    PANDORA_RELEASE_NODOTS_DATE=`date +%Y%m`
+
+    # Set some defaults
+    PANDORA_VC_REVNO="0"
+    PANDORA_VC_REVID="unknown"
+    PANDORA_VC_BRANCH="bzr-export"
+
+    if test "${pandora_building_from_bzr}" = "yes"; then
+      echo "# Grabbing changelog and version information from bzr"
+      PANDORA_BZR_REVNO=`bzr revno`
+      if test "x$PANDORA_BZR_REVNO" != "x${PANDORA_VC_REVNO}" ; then
+        PANDORA_VC_REVNO="${PANDORA_BZR_REVNO}"
+        PANDORA_VC_REVID=`bzr log -r-1 --show-ids | grep revision-id | cut -f2 -d' ' | head -1`
+        PANDORA_VC_BRANCH=`bzr nick`
+      fi
+    fi
+
+    if ! test -d config ; then
+      mkdir -p config
+    fi
+
+    cat > config/pandora_vc_revinfo.tmp <<EOF
+PANDORA_VC_REVNO=${PANDORA_VC_REVNO}
+PANDORA_VC_REVID=${PANDORA_VC_REVID}
+PANDORA_VC_BRANCH=${PANDORA_VC_BRANCH}
+PANDORA_RELEASE_DATE=${PANDORA_RELEASE_DATE}
+PANDORA_RELEASE_NODOTS_DATE=${PANDORA_RELEASE_NODOTS_DATE}
+EOF
+    if ! diff config/pandora_vc_revinfo.tmp config/pandora_vc_revinfo >/dev/null 2>&1 ; then
+      mv config/pandora_vc_revinfo.tmp config/pandora_vc_revinfo
+    fi
+    rm -f config/pandora_vc_revinfo.tmp
+  ])
 ])
   
-dnl Takes one argument which is the prefix to append
-AC_DEFUN([PANDORA_EXPORT_BZR_INFO],[
-  m4_ifval(m4_normalize([$1]),[
-    m4_define([PEBI_PREFIX],[])
-  ],[
-    m4_define([PEBI_PREFIX],m4_toupper(m4_normalize($1))[_])
-  ])
-
-  AC_DEFINE(PEBI_PREFIX[BZR_REVID], ["BZR_REVID"], [bzr revision ID])
-  AC_DEFINE(PEBI_PREFIX[BZR_BRANCH], ["BZR_BRANCH"], [bzr branch name])
-  AC_DEFINE(PEBI_PREFIX[RELEASE_DATE], ["RELEASE_DATE"], [Release date based on the date of the repo checkout])
-  AC_DEFINE(PEBI_PREFIX[RELEASE_VERSION], ["RELEASE_VERSION"], [$1 version number formatted for display])
-  AC_DEFINE(PEBI_PREFIX[RELEASE_COMMENT], ["RELEASE_COMMENT"], [Set to trunk if the branch is the main $1 branch])
-  AC_DEFINE(PEBI_PREFIX[RELEASE_ID], [RELEASE_ID], [$1 version number formatted for numerical comparison])
-])
-
 AC_DEFUN([_PANDORA_READ_FROM_FILE],[
   $1=`grep $1 $2 | cut -f2 -d=`
 ])
@@ -61,50 +81,23 @@
 AC_DEFUN([PANDORA_VC_VERSION],[
   AC_REQUIRE([PANDORA_BUILDING_FROM_VC])
 
-  PANDORA_RELEASE_DATE=`date +%Y.%m`
-  PANDORA_RELEASE_NODOTS_DATE=`date +%Y%m`
-
-  dnl Set some defaults
-  PANDORA_VC_REVNO="0"
-  PANDORA_VC_REVID="unknown"
-  PANDORA_VC_BRANCH="bzr-export"
-
-  AS_IF([test -f ${srcdir}/config/bzr_revinfo],[
-    _PANDORA_READ_FROM_FILE([PANDORA_VC_REVNO],${srcdir}/config/bzr_revinfo)
-    _PANDORA_READ_FROM_FILE([PANDORA_VC_REVID],${srcdir}/config/bzr_revinfo)
+  _PANDORA_BUILDING_FROM_VC
+
+  AS_IF([test -f ${srcdir}/config/pandora_vc_revinfo],[
+    _PANDORA_READ_FROM_FILE([PANDORA_VC_REVNO],${srcdir}/config/pandora_vc_revinfo)
+    _PANDORA_READ_FROM_FILE([PANDORA_VC_REVID],${srcdir}/config/pandora_vc_revinfo)
     _PANDORA_READ_FROM_FILE([PANDORA_VC_BRANCH],
-                            ${srcdir}/config/bzr_revinfo)
+                            ${srcdir}/config/pandora_vc_revinfo)
     _PANDORA_READ_FROM_FILE([PANDORA_RELEASE_DATE],
-                            ${srcdir}/config/bzr_revinfo)
+                            ${srcdir}/config/pandora_vc_revinfo)
     _PANDORA_READ_FROM_FILE([PANDORA_RELEASE_NODOTS_DATE],
-                            ${srcdir}/config/bzr_revinfo)
-    _PANDORA_READ_FROM_FILE([PANDORA_RELEASE_COMMENT],
-                            ${srcdir}/config/bzr_revinfo)
-  ])
-  AS_IF([test "${ac_cv_building_from_bzr}" = "yes"],[
-dnl  echo "Grabbing changelog and version information from bzr"
-dnl  bzr log --short > ChangeLog || touch ChangeLog
-    PANDORA_BZR_REVNO=`bzr revno`
-    AS_IF([test "x$PANDORA_BZR_REVNO" != "${PANDORA_VC_REVNO}"],[
-      PANDORA_VC_REVNO="${PANDORA_BZR_REVNO}"
-      PANDORA_VC_REVID=`bzr log -r-1 --show-ids | grep revision-id | awk '{print $[]2}' | head -1`
-      PANDORA_VC_BRANCH=`bzr nick`
-      AS_IF([test "x${PANDORA_VC_BRANCH}" != "${PACKAGE}"],[
-        PANDORA_RELEASE_COMMENT="${PANDORA_VC_BRANCH}"
-      ],[
-        PANDORA_RELEASE_COMMENT="trunk"
-      ])
-    ])
-  ])
-  AS_IF([! test -d config],[mkdir -p config])
-  cat > "config/bzr_revinfo" <<EOF
-PANDORA_VC_REVNO=${PANDORA_VC_REVNO}
-PANDORA_VC_REVID=${PANDORA_VC_REVID}
-PANDORA_VC_BRANCH=${PANDORA_VC_BRANCH}
-PANDORA_RELEASE_DATE=${PANDORA_RELEASE_DATE}
-PANDORA_RELEASE_NODOTS_DATE=${PANDORA_RELEASE_NODOTS_DATE}
-PANDORA_RELEASE_COMMENT=${PANDORA_RELEASE_COMMENT}
-EOF
+                            ${srcdir}/config/pandora_vc_revinfo)
+  ])
+  AS_IF([test "x${PANDORA_VC_BRANCH}" != x"${PACKAGE}"],[
+    PANDORA_RELEASE_COMMENT="${PANDORA_VC_BRANCH}"
+  ],[
+    PANDORA_RELEASE_COMMENT="trunk"
+  ])
     
   PANDORA_RELEASE_VERSION="${PANDORA_RELEASE_DATE}.${PANDORA_VC_REVNO}"
   PANDORA_RELEASE_ID="${PANDORA_RELEASE_NODOTS_DATE}${PANDORA_VC_REVNO}"
@@ -121,3 +114,17 @@
   AC_SUBST(PANDORA_RELEASE_VERSION)
   AC_SUBST(PANDORA_RELEASE_ID)
 ])
+
+AC_DEFUN([PANDORA_VC_INFO_HEADER],[
+  AC_REQUIRE([PANDORA_VC_VERSION])
+  m4_define([PANDORA_VC_PREFIX],m4_toupper(m4_normalize(AC_PACKAGE_NAME))[_])
+
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[VC_REVNO], [$PANDORA_VC_REVNO], [Version control revision number])
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[VC_REVID], ["$PANDORA_VC_REVID"], [Version control revision ID])
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[VC_BRANCH], ["$PANDORA_VC_BRANCH"], [Version control branch name])
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[RELEASE_DATE], ["$PANDORA_RELEASE_DATE"], [Release date of version control checkout])
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[RELEASE_NODOTS_DATE], [$PANDORA_RELEASE_NODOTS_DATE], [Numeric formatted release date of checkout])
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[RELEASE_COMMENT], ["$PANDORA_RELEASE_COMMENT"], [Set to trunk if the branch is the main $PACKAGE branch])
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[RELEASE_VERSION], ["$PANDORA_RELEASE_VERSION"], [Release date and revision number of checkout])
+  AC_DEFINE_UNQUOTED(PANDORA_VC_PREFIX[RELEASE_ID], [$PANDORA_RELEASE_ID], [Numeric formatted release date and revision number of checkout])
+])

=== modified file 'm4/pandora_warnings.m4'
--- m4/pandora_warnings.m4	2010-01-01 20:10:49 +0000
+++ m4/pandora_warnings.m4	2010-01-26 00:57:12 +0000
@@ -30,7 +30,7 @@
   AC_REQUIRE([PANDORA_BUILDING_FROM_VC])
   m4_if(PW_WARN_ALWAYS_ON, [yes],
     [ac_cv_warnings_as_errors=yes],
-    AS_IF([test "$ac_cv_building_from_vc" = "yes"],
+    AS_IF([test "$pandora_building_from_vc" = "yes"],
           [ac_cv_warnings_as_errors=yes],
           [ac_cv_warnings_as_errors=no]))
 

=== modified file 'm4/pandora_with_gettext.m4'
--- m4/pandora_with_gettext.m4	2009-11-11 04:40:26 +0000
+++ m4/pandora_with_gettext.m4	2010-02-12 20:31:36 +0000
@@ -11,10 +11,11 @@
 
 AC_DEFUN([PANDORA_WITH_GETTEXT],[
 
+  
   m4_syscmd([if test -d po ; then
     echo "# This file is auto-generated from configure. Do not edit directly" > po/POTFILES.in.stamp
-    PACKAGE=`grep ^AC_INIT configure.ac | cut -f2-3 -d[ | cut -f1 -d]`
-    for f in `find . | grep -v "${PACKAGE}-" | egrep '\.(cc|c|h|yy)$' | cut -c3- | sort`
+    PACKAGE=$(grep ^AC_INIT configure.ac | cut -f2-3 -d[ | cut -f1 -d])
+    for f in $(find . | grep -v "${PACKAGE}-" | egrep '\.(cc|c|h|yy)$' | cut -c3- | sort)
     do
       if grep gettext.h "$f" | grep include >/dev/null 2>&1
       then
@@ -29,13 +30,15 @@
     fi
   fi])
 
-  AM_GNU_GETTEXT(external, need-formatstring-macros)
-  AM_GNU_GETTEXT_VERSION([0.17])
-  AS_IF([test "x$MSGMERGE" = "x" -o "x$MSGMERGE" = "x:"],[
-    AM_PATH_PROG_WITH_TEST(GMSGMERGE, gmsgmerge,
-      [$ac_dir/$ac_word --update -q /dev/null /dev/null >&]AS_MESSAGE_LOG_FD[ 2>&1], :)
-    MSGMERGE="${GMSGMERGE}"
+  m4_if(m4_substr(m4_esyscmd(test -d po && echo 0),0,1),0, [
+    AM_GNU_GETTEXT(external, need-formatstring-macros)
+    AM_GNU_GETTEXT_VERSION([0.17])
+    AS_IF([test "x$MSGMERGE" = "x" -o "x$MSGMERGE" = "x:"],[
+      AM_PATH_PROG_WITH_TEST([GMSGMERGE], gmsgmerge,
+        [$ac_dir/$ac_word --update -q /dev/null /dev/null >&]AS_MESSAGE_LOG_FD[ 2>&1], :)
+      MSGMERGE="${GMSGMERGE}"
+    ])
+    AM_CONDITIONAL([BUILD_GETTEXT],[test "x$MSGMERGE" != "x" -a "x$MSGMERGE" != "x:"])
   ])
-  AM_CONDITIONAL([BUILD_GETTEXT],[test "x$MSGMERGE" != "x" -a "x$MSGMERGE" != "x:"])
 
 ])

=== modified file 'plugin/archive/ha_archive.h'
--- plugin/archive/ha_archive.h	2010-02-10 16:31:38 +0000
+++ plugin/archive/ha_archive.h	2010-02-12 21:18:37 +0000
@@ -47,7 +47,7 @@
   bool crashed;             /* Meta file is crashed */
   uint64_t mean_rec_length;
   char real_path[FN_REFLEN];
-  unsigned int  version;
+  uint64_t  version;
   drizzled::ha_rows rows_recorded;    /* Number of rows in tables */
   drizzled::ha_rows version_rows;
 };

=== modified file 'plugin/auth_http/auth_http.cc'
--- plugin/auth_http/auth_http.cc	2010-02-04 08:14:46 +0000
+++ plugin/auth_http/auth_http.cc	2010-02-10 23:50:24 +0000
@@ -77,7 +77,7 @@
     if (sysvar_auth_http_enable == false)
       return true;
 
-    assert(session->security_ctx.user.c_str());
+    assert(session->getSecurityContext().getUser().c_str());
     assert(password);
 
 
@@ -86,12 +86,12 @@
 #if defined(HAVE_CURLOPT_USERNAME)
 
     rv= curl_easy_setopt(curl_handle, CURLOPT_USERNAME,
-                         session->security_ctx.user.c_str());
+                         session->getSecurityContext().getUser().c_str());
     rv= curl_easy_setopt(curl_handle, CURLOPT_PASSWORD, password);
 
 #else
 
-    string userpwd= session->security_ctx.user;
+    string userpwd= session->getSecurityContext().getUser();
     userpwd.append(":");
     userpwd.append(password);
     rv= curl_easy_setopt(curl_handle, CURLOPT_USERPWD, userpwd.c_str());

=== modified file 'plugin/auth_pam/auth_pam.cc'
--- plugin/auth_pam/auth_pam.cc	2010-02-04 08:14:46 +0000
+++ plugin/auth_pam/auth_pam.cc	2010-02-10 23:50:24 +0000
@@ -111,7 +111,7 @@
     struct pam_conv conv_info= { &auth_pam_talker, (void*)&userinfo };
     pam_handle_t *pamh= NULL;
 
-    userinfo.name= session->security_ctx.user.c_str();
+    userinfo.name= session->getSecurityContext().getUser().c_str();
     userinfo.password= password;
 
     retval= pam_start("check_user", userinfo.name, &conv_info, &pamh);

=== modified file 'plugin/drizzle_protocol/oldlibdrizzle.cc'
--- plugin/drizzle_protocol/oldlibdrizzle.cc	2010-02-04 08:14:46 +0000
+++ plugin/drizzle_protocol/oldlibdrizzle.cc	2010-02-11 01:48:23 +0000
@@ -20,7 +20,6 @@
 #include "config.h"
 #include <drizzled/gettext.h>
 #include <drizzled/error.h>
-#include "drizzled/my_error.h"
 #include <drizzled/query_id.h>
 #include <drizzled/sql_state.h>
 #include <drizzled/session.h>
@@ -638,11 +637,11 @@
 
     if (drizzleclient_net_peer_addr(&net, ip, &peer_port, NI_MAXHOST))
     {
-      my_error(ER_BAD_HOST_ERROR, MYF(0), session->security_ctx.ip.c_str());
+      my_error(ER_BAD_HOST_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
       return false;
     }
 
-    session->security_ctx.ip.assign(ip);
+    session->getSecurityContext().setIp(ip);
   }
   drizzleclient_net_keepalive(&net, true);
 
@@ -697,7 +696,7 @@
         ||    (pkt_len= drizzleclient_net_read(&net)) == packet_error 
         || pkt_len < MIN_HANDSHAKE_SIZE)
     {
-      my_error(ER_HANDSHAKE_ERROR, MYF(0), session->security_ctx.ip.c_str());
+      my_error(ER_HANDSHAKE_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
       return false;
     }
   }
@@ -719,7 +718,7 @@
 
   if (end >= (char*) net.read_pos + pkt_len + 2)
   {
-    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->security_ctx.ip.c_str());
+    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
     return false;
   }
 
@@ -749,7 +748,7 @@
 
   if (passwd + passwd_len + db_len > (char *) net.read_pos + pkt_len)
   {
-    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->security_ctx.ip.c_str());
+    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
     return false;
   }
 
@@ -761,7 +760,7 @@
     user_len-= 2;
   }
 
-  session->security_ctx.user.assign(user);
+  session->getSecurityContext().setUser(user);
 
   return session->checkUser(passwd, passwd_len, l_db);
 }

=== modified file 'plugin/heap/hp_create.cc'
--- plugin/heap/hp_create.cc	2010-02-04 08:14:46 +0000
+++ plugin/heap/hp_create.cc	2010-02-11 01:35:55 +0000
@@ -17,7 +17,6 @@
 
 #include <drizzled/common.h>
 #include <drizzled/error.h>
-#include "drizzled/my_error.h"
 
 #include <string.h>
 #include <algorithm>

=== modified file 'plugin/info_schema/processlist.cc'
--- plugin/info_schema/processlist.cc	2010-02-04 08:14:46 +0000
+++ plugin/info_schema/processlist.cc	2010-02-10 23:50:24 +0000
@@ -190,7 +190,7 @@
     for (vector<Session*>::iterator it= getSessionList().begin(); it != getSessionList().end(); ++it)
     {
       tmp= *it;
-      Security_context *tmp_sctx= &tmp->security_ctx;
+      const SecurityContext *tmp_sctx= &tmp->getSecurityContext();
       internal::st_my_thread_var *mysys_var;
       const char *val;
 
@@ -209,10 +209,10 @@
       /* ID */
       table->field[0]->store((int64_t) tmp->thread_id, true);
       /* USER */
-      val= tmp_sctx->user.c_str() ? tmp_sctx->user.c_str() : "unauthenticated user";
+      val= tmp_sctx->getUser().c_str() ? tmp_sctx->getUser().c_str() : "unauthenticated user";
       table->field[1]->store(val, strlen(val), cs);
       /* HOST */
-      table->field[2]->store(tmp_sctx->ip.c_str(), strlen(tmp_sctx->ip.c_str()), cs);
+      table->field[2]->store(tmp_sctx->getIp().c_str(), strlen(tmp_sctx->getIp().c_str()), cs);
       /* DB */
       if (! tmp->db.empty())
       {

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2010-02-11 03:29:52 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2010-02-13 01:41:44 +0000
@@ -68,7 +68,6 @@
 #include "drizzled/internal/m_string.h"
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/my_hash.h"
-#include "drizzled/my_error.h"
 #include "drizzled/plugin.h"
 #include "drizzled/show.h"
 #include "drizzled/data_home.h"
@@ -978,8 +977,8 @@
           static_cast<uint64_t>(session_get_thread_id( session)),
           static_cast<uint64_t>(session->getQueryId()),
           glob_hostname,
-          session->security_ctx.ip.c_str(),
-          session->security_ctx.user.c_str()
+          session->getSecurityContext().getIp().c_str(),
+          session->getSecurityContext().getUser().c_str()
   );
   fprintf(f,
           "\n%s", session->getQueryString().c_str()

=== modified file 'plugin/innobase/handler/handler0alter.cc'
--- plugin/innobase/handler/handler0alter.cc	2009-12-23 21:16:15 +0000
+++ plugin/innobase/handler/handler0alter.cc	2010-01-22 02:01:19 +0000
@@ -28,7 +28,6 @@
 #include <drizzled/table.h>
 #include <drizzled/field/varstring.h>
 #include "drizzled/internal/my_sys.h"
-#include "drizzled/my_error.h"
 
 extern "C" {
 #include "log0log.h"

=== modified file 'plugin/innobase/handler/i_s.cc'
--- plugin/innobase/handler/i_s.cc	2010-02-04 08:14:46 +0000
+++ plugin/innobase/handler/i_s.cc	2010-02-11 01:35:55 +0000
@@ -28,7 +28,6 @@
 #include "drizzled/charset_info.h"
 #include "drizzled/internal/my_sys.h"
 #include <drizzled/my_hash.h>
-#include "drizzled/my_error.h"
 #include <drizzled/plugin.h>
 #include <drizzled/field.h>
 #include <drizzled/table.h>

=== removed file 'plugin/memcached_functions/plugin.ac'
--- plugin/memcached_functions/plugin.ac	2009-12-18 08:15:06 +0000
+++ plugin/memcached_functions/plugin.ac	1970-01-01 00:00:00 +0000
@@ -1,6 +0,0 @@
-PANDORA_HAVE_LIBMEMCACHED
-PANDORA_HAVE_MEMCACHED
-AS_IF([test "x$ac_cv_libmemcached" = "xno" -a "x${MEMCACHED_BINARY}" = "xyes"],
-      AC_MSG_WARN([libmemcached not found: not building memcached_functions plugin.]))
-DRIZZLED_PLUGIN_DEP_LIBS="${DRIZZLED_PLUGIN_DEP_LIBS} ${LTLIBMEMCACHED}"
-AC_CONFIG_FILES([plugin/memcached_functions/start_mc.sh])

=== modified file 'plugin/memcached_functions/plugin.ini'
--- plugin/memcached_functions/plugin.ini	2009-12-04 18:50:04 +0000
+++ plugin/memcached_functions/plugin.ini	2010-02-12 02:56:22 +0000
@@ -1,7 +1,8 @@
 [plugin]
 title=Memcached Client UDFs
 description=UDF plugin for libmemcached
-load_by_default=yes
+load_by_default=no
+disabled=yes
 headers=memcached_functions.h 
         memc_get.h memc_get_by_key.h
         memc_set.h memc_set_by_key.h 

=== modified file 'plugin/memcached_stats/plugin.ini'
--- plugin/memcached_stats/plugin.ini	2009-12-04 18:50:04 +0000
+++ plugin/memcached_stats/plugin.ini	2010-02-12 02:56:22 +0000
@@ -1,7 +1,8 @@
 [plugin]
 title=Memcached Stats in I_S tables
 description=Some I_S tables that provide Memcached stats
-load_by_default=yes
+disabled=yes
+load_by_default=no
 headers=stats_table.h analysis_table.h sysvar_holder.h
 sources=memcached_stats.cc stats_table.cc analysis_table.cc
 build_conditional="${ac_cv_libmemcached}" = "yes" -a "x${MEMCACHED_BINARY}" != "xno"

=== modified file 'plugin/memcached_stats/stats_table.cc'
--- plugin/memcached_stats/stats_table.cc	2010-01-09 22:01:00 +0000
+++ plugin/memcached_stats/stats_table.cc	2010-01-22 02:01:19 +0000
@@ -30,7 +30,7 @@
 #include "config.h"
 #include "drizzled/session.h"
 #include "drizzled/show.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #include "stats_table.h"
 #include "sysvar_holder.h"

=== modified file 'plugin/myisam/mf_keycache.cc'
--- plugin/myisam/mf_keycache.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mf_keycache.cc	2010-02-11 01:35:55 +0000
@@ -102,7 +102,7 @@
 */
 
 #include "config.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include "drizzled/internal/my_sys.h"
 #include "keycache.h"
 #include "drizzled/internal/m_string.h"

=== modified file 'plugin/myisam/mi_check.cc'
--- plugin/myisam/mi_check.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_check.cc	2010-02-11 01:35:55 +0000
@@ -54,7 +54,7 @@
 #include <sys/mman.h>
 #endif
 #include <drizzled/util/test.h>
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #include <algorithm>
 

=== modified file 'plugin/myisam/mi_create.cc'
--- plugin/myisam/mi_create.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_create.cc	2010-02-11 01:35:55 +0000
@@ -21,7 +21,7 @@
 
 #include "drizzled/util/test.h"
 #include "drizzled/global_charset_info.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #include <cassert>
 #include <algorithm>

=== modified file 'plugin/myisam/mi_dynrec.cc'
--- plugin/myisam/mi_dynrec.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_dynrec.cc	2010-02-11 01:35:55 +0000
@@ -32,7 +32,7 @@
 #include <sys/mman.h>
 #endif
 #include <drizzled/util/test.h>
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #include <cassert>
 #include <algorithm>

=== modified file 'plugin/myisam/mi_info.cc'
--- plugin/myisam/mi_info.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_info.cc	2010-02-11 01:35:55 +0000
@@ -17,7 +17,7 @@
 
 #include "myisam_priv.h"
 #include <sys/stat.h>
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 using namespace drizzled;
 

=== modified file 'plugin/myisam/my_handler_errors.cc'
--- plugin/myisam/my_handler_errors.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/my_handler_errors.cc	2010-02-11 01:35:55 +0000
@@ -21,7 +21,7 @@
 #include <drizzled/base.h>
 #include "drizzled/internal/my_sys.h"
 #include <plugin/myisam/my_handler.h>
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 
 #include <drizzled/gettext.h>
 

=== modified file 'plugin/myisam/my_pread.cc'
--- plugin/myisam/my_pread.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/my_pread.cc	2010-02-11 01:35:55 +0000
@@ -14,7 +14,7 @@
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
 #include "myisam_priv.h"
-#include "drizzled/my_error.h"
+#include "drizzled/error.h"
 #include <cerrno>
 #include <unistd.h>
 

=== modified file 'plugin/mysql_protocol/oldlibdrizzle.cc'
--- plugin/mysql_protocol/oldlibdrizzle.cc	2010-02-04 08:14:46 +0000
+++ plugin/mysql_protocol/oldlibdrizzle.cc	2010-02-10 23:50:24 +0000
@@ -623,11 +623,11 @@
 
     if (drizzleclient_net_peer_addr(&net, ip, &peer_port, NI_MAXHOST))
     {
-      my_error(ER_BAD_HOST_ERROR, MYF(0), session->security_ctx.ip.c_str());
+      my_error(ER_BAD_HOST_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
       return false;
     }
 
-    session->security_ctx.ip.assign(ip);
+    session->getSecurityContext().setIp(ip);
   }
   drizzleclient_net_keepalive(&net, true);
 
@@ -682,7 +682,7 @@
         ||    (pkt_len= drizzleclient_net_read(&net)) == packet_error 
         || pkt_len < MIN_HANDSHAKE_SIZE)
     {
-      my_error(ER_HANDSHAKE_ERROR, MYF(0), session->security_ctx.ip.c_str());
+      my_error(ER_HANDSHAKE_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
       return false;
     }
   }
@@ -704,7 +704,7 @@
 
   if (end >= (char*) net.read_pos + pkt_len + 2)
   {
-    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->security_ctx.ip.c_str());
+    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
     return false;
   }
 
@@ -734,7 +734,7 @@
 
   if (passwd + passwd_len + db_len > (char *) net.read_pos + pkt_len)
   {
-    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->security_ctx.ip.c_str());
+    my_error(ER_HANDSHAKE_ERROR, MYF(0), session->getSecurityContext().getIp().c_str());
     return false;
   }
 
@@ -746,7 +746,7 @@
     user_len-= 2;
   }
 
-  session->security_ctx.user.assign(user);
+  session->getSecurityContext().setUser(user);
 
   return session->checkUser(passwd, passwd_len, l_db);
 }

=== modified file 'tests/test-run.pl'
--- tests/test-run.pl	2010-02-05 18:02:02 +0000
+++ tests/test-run.pl	2010-02-12 19:36:27 +0000
@@ -3248,7 +3248,7 @@
   {
     # write init file for drizzled
     mtr_tofile($dbx_init_file,
-               "stop in mysql_parse\n" .
+               "stop in drizzled::mysql_parse\n" .
                "runargs $str\n" .
                "run\n" .
                "\n");
@@ -3304,7 +3304,7 @@
     # write init file for mysqld
     mtr_tofile($gdb_init_file,
 	       "set args $str\n" .
-	       "break mysql_parse\n" .
+	       "break drizzled::mysql_parse\n" .
 	       "commands 1\n" .
 	       "disable 1\n" .
 	       "end\n" .
@@ -3369,7 +3369,7 @@
     mtr_tofile($gdb_init_file,
 	       "file $$exe\n" .
 	       "set args $str\n" .
-	       "break mysql_parse\n" .
+	       "break drizzled::mysql_parse\n" .
 	       "commands 1\n" .
 	       "disable 1\n" .
 	       "end");

=== modified file 'tests/valgrind.supp'
--- tests/valgrind.supp	2010-02-04 08:14:46 +0000
+++ tests/valgrind.supp	2010-02-13 00:05:34 +0000
@@ -330,7 +330,7 @@
    fun:_ZN8drizzled12mysql_insertEPNS_7SessionEPNS_9TableListERNS_4ListINS_4ItemEEERNS4_IS6_EES7_S7_NS_15enum_duplicatesEb
    fun:_ZN8drizzled9statement6Insert7executeEv
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
    fun:_ZN8drizzled7Session3runEv
@@ -350,7 +350,7 @@
    fun:_ZN8drizzled13handle_selectEPNS_7SessionEPNS_3LEXEPNS_13select_resultEm
    fun:_ZN8drizzled21execute_sqlcom_selectEPNS_7SessionEPNS_9TableListE
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
    fun:_ZN8drizzled7Session3runEv
@@ -846,7 +846,7 @@
    fun:_ZN8drizzled12mysql_insertEPNS_7SessionEPNS_9TableListERNS_4ListINS_4ItemEEERNS4_IS6_EES7_S7_NS_15enum_duplicatesEb
    fun:_ZN8drizzled9statement6Insert7executeEv
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
 }
 
 {
@@ -864,7 +864,7 @@
    fun:_ZN8drizzled12mysql_insertEPNS_7SessionEPNS_9TableListERNS_4ListINS_4ItemEEERNS4_IS6_EES7_S7_NS_15enum_duplicatesEb
    fun:_ZN8drizzled9statement6Insert7executeEv
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
 }
@@ -1200,7 +1200,7 @@
    fun:_ZN8drizzled13handle_selectEPNS_7SessionEPNS_3LEXEPNS_13select_resultEm
    fun:_ZN8drizzled21execute_sqlcom_selectEPNS_7SessionEPNS_9TableListE
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
    fun:_ZN8drizzled7Session3runEv
@@ -1246,7 +1246,7 @@
    fun:_ZN8drizzled13handle_selectEPNS_7SessionEPNS_3LEXEPNS_13select_resultEm
    fun:_ZN8drizzled21execute_sqlcom_selectEPNS_7SessionEPNS_9TableListE
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
    fun:_ZN8drizzled7Session3runEv
@@ -1281,7 +1281,7 @@
    fun:_ZN8drizzled13handle_selectEPNS_7SessionEPNS_3LEXEPNS_13select_resultEm
    fun:_ZN8drizzled21execute_sqlcom_selectEPNS_7SessionEPNS_9TableListE
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
    fun:_ZN8drizzled7Session3runEv
@@ -1302,7 +1302,7 @@
    fun:_ZN8drizzled13handle_selectEPNS_7SessionEPNS_3LEXEPNS_13select_resultEm
    fun:_ZN8drizzled21execute_sqlcom_selectEPNS_7SessionEPNS_9TableListE
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
    fun:_ZN8drizzled7Session3runEv
@@ -1310,7 +1310,6 @@
    fun:start_thread
 }
 
-
 {
    Badness inside of libc.
    Memcheck:Leak
@@ -1346,7 +1345,7 @@
    fun:_ZN8drizzled18mysql_create_tableEPNS_7SessionERNS_15TableIdentifierEPNS_24st_ha_create_informationEPNS_7message5TableEPNS_9AlterInfoEbjb
    fun:_ZN8drizzled9statement11CreateTable7executeEv
    fun:_ZN8drizzledL21mysql_execute_commandEPNS_7SessionE
-   fun:_ZN8drizzledL11mysql_parseEPNS_7SessionEPKcjPS3_
+   fun:_ZN8drizzled11mysql_parseEPNS_7SessionEPKcjPS3_
    fun:_ZN8drizzled16dispatch_commandENS_19enum_server_commandEPNS_7SessionEPcj
    fun:_ZN8drizzled7Session16executeStatementEv
    fun:_ZN8drizzled7Session3runEv

